package gol;

import java.awt.event.KeyEvent;
import java.util.List;

import view.*;
import view.gui.*;
import model.*;

public class GoL implements View.MouseL, View.MouseMotionL, View.KeyL, View.FrameUpdateL {
	View view;
	Model model;
	
	MainMenu mainmenu;
	FixPaint paint;
	StatsWindow  stats;
	
	public GoL() {
		model = new Model();
		view = new View(model);
		view.addMouseMotionL(this);
		view.addFrameUpdateL(this);
		view.addKeyL(this);
		view.addMouseL(this);
		
		mainmenu = new MainMenu();
		model.getWM().add(mainmenu);
		mainmenu.initWM(model.getWM());
		mainmenu.move(20, 20);
		mainmenu.initsModel(model);
		
		stats = new StatsWindow();
		model.getWM().add(stats);
		stats.initWM(model.getWM());
		stats.move(300, 50);
		
		/*
		mainform = new MainForm(view);
		model.formPush(mainform);
		*/
		view.start();
	}
	
	public static void main(String[] args) {
		
		//System.out.println("[main] " + new Bullet(Bullet.Type.Creeper).getLongName());
		//System.out.println("[main[ " + new Bullet(Bullet.Type.Creeper).getLongType());
		
		GoL gol = new GoL();
	}

	@Override
	public void updateFrame(float delta) {
		/* 110629: commented out: minecraftification
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				Pixie pix = model.get(x,y);
				if (pix == null) { continue; }
				
				pix.update(model, delta);
				
				/*
				Player p = model.getPlayer();
				if (p == null) model.termPost("CORE[GoL.updateFrame]: mode.getPlayer() returned NULL!");
				** /
			}
		}
		List<Pixie> enten = model.entenGet();
		for (int i = 0; i < enten.size(); i++) {
			Pixie pix = enten.get(i);
			if (pix == null) continue;
			pix.update(model, delta);
		}
		
		model.getPlayer().update(model, delta);
		*/
	}

	 
	@Override
	public boolean mouseClicked(int x, int y) {
		if (model.useForms() && model.getWM().mouseClicked(x, y)) return true;
		
		// ===
		
		for (int i=0; i<4; i++) {
			/* 110629: commented out: minecraftification &&& simply no shooting
			Thing projectile = new Bullet(Bullet.Type.STD);
			// use 300f as speed
			model.getPlayer().shoot(x, y, 200f, (float)(Math.atan2(y-model.getPlayer().y, x-model.getPlayer().x)), projectile);
			model.entenAdd(projectile);
			*/
		}
		return true;
	}
	public boolean mouseMoved(int x, int y) {
		if (model.useForms() && model.getWM().mouseMoved(x, y)) return true;
		
		// ===
		
		return false;
	}
 	public boolean mouseDragged(int x, int y) {
		if (model.useForms() && model.getWM().mouseDragged(x, y)) return true;
		
		// ===
		
		return false;
		
		/*
		model.set((float)x  , (float)y  , new Dirt());
		model.set((float)x+1, (float)y  , new Dirt());
		model.set((float)x-1, (float)y  , new Dirt());
		model.set((float)x  , (float)y+1, new Dirt());
		model.set((float)x  , (float)y-1, new Dirt());
		*/
		//model.set(x-1, y-1, new Pixie(-1));
		//model.set(x-1, y+1, new Pixie(-1));
		//model.set(x+1, y-1, new Pixie(-1));
		//model.set(x+1, y+1, new Pixie(-1));
		//model.termPost("You set a pixel at x:"+x+"|y:"+y);
		//return true; // we consumed it.!
		//return false;
	}
	public boolean keyTyped(char letter) {
		if (model.useForms() && model.getWM().keyTyped(letter)) return true;
		
		// ===
		
		return false;
	}
	public boolean keyPressed(int code) {
		if (code == KeyEvent.VK_ESCAPE) { model.useForms(!model.useForms()); return true; }
		
		if (model.useForms() && model.getWM().keyPressed(code)) return true;
		
		
		switch (code) {
		/*case KeyEvent.VK_ESCAPE:
			model.useForms(!model.useForms()); // always toggle
			return true;*/
			
		case KeyEvent.VK_UP:
			model.getPlayer().move(model.getPlayer().getX(), model.getPlayer().getY()-1);
			break;
		
		case KeyEvent.VK_DOWN:
			model.getPlayer().move(model.getPlayer().getX(), model.getPlayer().getY()+1);
			break;
			
		case KeyEvent.VK_LEFT:
			model.getPlayer().move(model.getPlayer().getX()-1, model.getPlayer().getY());
			break;
			
		case KeyEvent.VK_RIGHT:
			model.getPlayer().move(model.getPlayer().getX()+1, model.getPlayer().getY());
			break;
			
		case KeyEvent.VK_Q:
			model.createMaze();
			break;
		}
		return false;
	}

	public boolean mouseDown(int x, int y) {
		if (model.useForms() && model.getWM().mouseDown(x,y)) return true;
		return false;
	}
	public boolean mouseUp(int x, int y) {
		if (model.useForms() && model.getWM().mouseUp(x,y)) return true;
		return false;
	}
}


















