package model;

import java.util.LinkedList;
import java.util.List;

import mutil.Avoid;

public class Chunk {
	public static final int cs = 64; // Chunksize 64x64

	Block[][] data;
	public final int x, y; // 0:1st chunk. 1:second chunk. (not 64:second chunk)
	public World world; // in which world am i ?

	List<Entity> entities;

	public Chunk(World world, int x, int y) {
		this.world = world;
		this.x = x;
		this.y = y;
		data = new Block[cs][cs];
		for (int mx = 0; mx < cs; mx++) {
			for (int my = 0; my < cs; my++) {
				data[mx][my] = Block.air;
			}
		}

		entities = new LinkedList<Entity>();
	}

	public List<Entity> getEntities() {
		return entities;
	}

	public int getWorldPosX() {
		return x * cs;
	}

	public int getWorldPosY() {
		return y * cs;
	}

	public @Deprecated
	int getPosX() {
		return x;
	}

	public @Deprecated
	int getPosY() {
		return y;
	}

	public @Avoid("")
	World getWorld() {
		return world;
	}

	public void entityadd(Entity e) {
		entities.add(e);
	}

	public void entityrem(long eid) {
		for (Entity e : entities) {
			if (e.eid == eid) {
				entities.remove(e);
				return;
			}
		}
	}

	public void entityrem(Entity e) {
		entities.remove(e);
	}

	public Block getr(int x, int y) {
		if (x >= 0 && y >= 0 && x < cs && y < cs) {
			return data[x][y];
		} else {
			return Block.air;
		}
	}

	public Block geta(int x, int y) {
		if (x >= (this.x * cs) && y >= (this.y * cs) && x < (this.x * cs) + cs
				&& y < (this.y * cs) + cs) {
			return data[x % cs][y % cs];
		} else {
			return Block.air;
		}
	}

	public void setr(int x, int y, Block data) {
		if (x >= 0 && y >= 0 && x < cs && y < cs) {
			this.data[x][y] = data;
		}
	}

	public void seta(int x, int y, Block data) {
		if (x >= (this.x * cs) && y >= (this.y * cs) && x < (this.x * cs) + cs
				&& y < (this.y * cs) + cs) {
			this.data[x - (this.x * cs)][y - (this.y * cs)] = data;
		} else {
			return;
		}
	}

}
