package model;

import java.util.LinkedList;
import java.util.List;

public class Chunk {
	public static final int cs = 64; // Chunksize 64x64
	
	short[][] data;
	public final int x, y;
	public World world; // in which world am i ?
	
	List<Entity> entities;
	
	public Chunk(World world, int x, int y) {
		this.world = world;
		this.x = x;
		this.y = y;
		data = new short[cs][cs];
		entities = new LinkedList<Entity>();
	}
	
	public World getWorld() { return world; }
	
	public void entityadd(Entity e) { entities.add(e); }
	public void entityrem(long eid) { entities.remove(eid); }
	public void entityrem(Entity e) { entities.remove(e); }
	
	public short get(int x, int y)
	{
		if (x>=0 && y>=0 && x<cs && y<cs)
		{
			return data[x][y];
		}else
		{
			return 0;
		}
	}
	
	public void set(int x, int y, short data)
	{
		if (x>=0 && y>=0 && x<cs && y<cs)
		{
			this.data[x][y] = data;
		}else
		{
			return;
		}
	}
	
}
