package model;

public class Entity {
	protected double x, y; // finer calculations only with entities
	protected final long eid; // entitiy global ID
	protected Chunk chunk; // in which chunk am i ?
	protected final World world;
	
	public Entity(World in, double x, double y) {
		if (in == null) { throw new IllegalArgumentException("(World)in must not be null."); }
		this.x = x;
		this.y = y;
		this.chunk = in.ensureChunkAt((int)x, (int)y);
		this.chunk.entityadd(this);
		this.world = in;
		this.eid = in.entityallocate(this);
	}
	
	public boolean isOpaque() { return false; }
	
	public static final Entity decode(String str) {
		return null; // TODO
	}
	
	public String encode() {
		String ret = "";
		
		ret+=eid+",";
		ret+=x+","+y;
		
		return ret;
	}
	
	public double getX() { return x; }
	public double getY() { return y; }
	
	public void update(double delta) { }
	
	public void destroyme() { if (world != null) world.entitykill(eid); else chunk.getWorld().entitykill(eid); }
	
	public World getWorld() { return world; }
	public Chunk getChunk() { return chunk; }
	public long getEID() { return eid; }
	
	public void move(double x, double y) {
		Chunk nc = chunk.getWorld().ensureChunkAt((int)x, (int)y);
		this.x = x; this.y = y;
		if (nc == chunk) return;
		chunk.entityrem(this);
		nc.entityadd(this);
		System.out.printf("Entity #%d: from %s to %s\n", eid, chunk, nc);
		
		chunk = nc;
	}
}
