package model;

public class Entity {
	protected double x, y; // finer calculations only with entities
	protected final long eid; // entitiy global ID
	private Chunk chunk; // in which chunk am i ?
	private World world;
	
	public Entity(World in, long eid, double x, double y) {
		this.eid = eid;
		this.x = x;
		this.y = y;
		this.chunk = in.getChunkAt((int)x, (int)y);
		this.world = in;
	}
	public Entity(Chunk in, long eid, double x, double y) {
		this(in.getWorld(), eid, x, y);
		// ASSERT Entity with chunk instead of world called!
	}
	
	public void destroyme() { if (world != null) world.entitykill(eid); else chunk.getWorld().entitykill(eid); }
	
	public World getWorld() { return world; }
	public Chunk getChunk() { return chunk; }
	public long getEID() { return eid; }
	
	public void move(double x, double y) {
		Chunk nc = chunk.getWorld().ensureChunkAt((int)x, (int)y);
		if (nc == chunk) { this.x=x;this.y=y; return; }
		nc.entityadd(this);
	}
}
