package model;

import view.GSnip;
import model.pixies.Bullet;
import model.pixies.Pixie;

/**Note that im not planning on using this class for player inventory only.
 * Maybe also monsters will have these. Chests for sure. (Furnaces?)
 * (Mass furnaces?) (Chickens?)
 */

public class Inventory {
	public enum Type {
		ERROR,	// Error code
		STD,	// use this by default if too lazy to add your own class to this enummmmm.. -.-
		
		Player, // WIP
		PlayerPalette,
		PlayerArmor,
		
		Chest, // TODO
		
		Furnace, // TODO
		// etc. Creating your own Inventories, please also add them here!
	} Type type;
	public static Type str2type(String in) {
			 if (in == "STD") return Type.STD;
		else if (in == "Player") return Type.Player;
		else if (in == "Chest") return Type.Chest;
		else if (in == "Furnace") return Type.Furnace;
		
		else return Type.ERROR;
	}
	public static String type2str(Type type) {
		switch(type) {
		case ERROR: return "ERROR";
		case STD: return "STD";
		case Player: return "Player";
		case Chest: return "Chest";
		case Furnace: return "Furnace";
		}
		return "ERROR";
	}
	/**Examples of returns:
	 * Inventory.ERROR
	 * Inventory.STD
	 * Inventory.Player
	 * Inventory.Chest
	 * Inventory.Player.Palette
	 * Inventory.Player.Armor
	 */
	public String getLongName() {
		return "Inventory." + type2str(type);
	}
	
	public class Slot { // ==== - ====
		public Pixie[] items;
		public int quantity;
		public String type; // pixie type
		public GSnip img; // image to display in palette/inventory
		
		public Slot() { // simplification
			this(64); // default stacklen
		}
		public Slot(int stacklen) { // main constructor.
			quantity = 0;
			items = new Pixie[stacklen];
		}
		public Slot(int stacklen, Pixie anything) { // extension
			this(stacklen);
			items[0] = anything;
		}
		
		public GSnip getImg() { return img; }
		
		public String getType() { return type; }
		public void   setType(Pixie sample)		{ this.type = sample.getLongType(); }
		public void   setType(String pixietype) { this.type = pixietype; }
		public void   resetType()               { this.type = null; }
		
		/**Add an element to the stack of Pixies
		 * @param anything Any pixie to add.
		 * @return (ret<0:fail) positive:index; -1:No Free slot; -2:Type mismatch.
		 */
		public int push(Pixie anything) {
			if (quantity == 0) {
				this.type = anything.getLongType();
				this.img = anything.getImg();
			} else if (anything.getLongType() != type) return -2;
			
			// TODO make list reverse
			for (int i=0; i<64; i++) {
				if (items[i] == null || items[i].getT() == Pixie.Type.NULL) {
					items[i] = anything;
					quantity++;
					return i; // success
				}
			}
			return -1;
		}
		/** Finds the first non-null Pixie. And removes it */
		public Pixie pop() {
			for (int i=0; i<64; i++) {
				if (items[i] != null) {
					Pixie ret = items[i];
					items[i] = null; // equivalent to removing it
					quantity--;
					return ret;
				}
			}
			return null;
		}
		/**Gives the next element to be put out.
		 * But doesnt remove it
		 */
		public Pixie top() {
			if (quantity == 0) return null;
			for (int i=0; i<64; i++) {
				if (items[i] != null) return items[i];
			}
			System.out.println("BUG >> [model.Inventory.top] reached end of function, which should be unreachable!");
			return null;
		}

	} // ====/ class Slot ====
	
	private Slot[] slots;
	
	/**Allocate inventory
	 * @param Player, Chest, Monster's inv(loot), etc
	 * @param amount 8*3 is default
	 */
	public Inventory(Type type, int amount) {
		this.type = type;
		slots = new Slot[amount];
		for (int i=0; i<amount; i++) {
			slots[i] = new Slot();
		}
	}
	
	public Slot get(int index) {
		if (index<0 || index>=slots.length) return null;
		return slots[index];
	}
	public void set(int index, Slot slot) {
		System.out.printf("model.Inventory.set: called\n");
		if (index<0 || index>=slots.length) return;
		System.out.printf("model.Inventory.set: overwriting index %d\n", index);
		slots[index] = slot;
	}
}










