package model;

import java.util.*;

import view.GSnip;

public class InventorySlot {
	public static final int ss = 64; // max. stacksize
	
	private Object[] list;
	private final Class<? extends Object> type;
	private boolean isempty;
	private int quantity;
	private final GSnip icon;
	
	public InventorySlot(Object first) {
		if (first instanceof Block) icon = Lib.icons.byBlock((Block)first);
		else if (first instanceof Entity) icon = Lib.icons.byEntity((Entity)first);
		else throw new IllegalArgumentException("(Object)first must be instaceof Block or Entity.");
		
		list = new Object[ss];
		this.type = first.getClass();
		list[0] = first;
		isempty = false;
		quantity = 1;
	}
	
	public GSnip getIcon() { return icon; }
	public boolean isCompatible(Object wut) { if (wut.getClass().equals(this.type)) return true; else return false; }
	public boolean push(Object wut) {
		if (!isCompatible(wut)) return false;
		
		for (int i=0; i<ss; i++) {
			if (list[i] == null) {
				list[i] = wut;
				quantity++;
				return true;
			}
		}
		
		isempty = false;
		return false;
	}
	public Object  pop() {
		for (int i=0; i<ss; i++) {
			if (list[i] != null) {
				Object ret = list[i];
				list[i] = null;
				if (i==ss-1) isempty=true;
				
				quantity--;
				return ret;
			}
		}
		isempty = true;
		return null;
	}
	public Object  peek() {
		for (int i=0; i<ss; i++) if (list[i] != null) return list[i];
		
		isempty=true;
		return null;
	}
	public boolean isEmpty() { return isempty; }
	public int getQuantity() { return quantity; }
}
