package model;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;

import view.GSnip;

// loads block-icons and entity-icons
// to display them in the inventory

public class LibIcons {
	public static final int iconsize = 24;
	public static final int ipr = 16; // icons per row: 16*16 = 256 images
	
	private final GSnip[] data;
	
	LibIcons(String filename) {
		data = new GSnip[ipr*ipr];
		
		Color alphakey = new Color(255,0,255); // fuchsia
		Color transparent = new Color(0,0,0,0);
		
		BufferedImage img = null;
		try {
			img = ImageIO.read(new File(new File(".").getCanonicalPath() + "/" + filename));
			for (int x=0; x<ipr; x++) {
				for (int y=0; y<ipr; y++) {
					GSnip gs = new GSnip(iconsize, iconsize);

					for (int mx=0; mx<iconsize; mx++) {
						for (int my=0; my<iconsize; my++) {
							Color c = new Color(img.getRGB(mx+x*iconsize, my+y*iconsize));
							if (c.equals(alphakey)) c = transparent;
							gs.setraw(mx, my, c);
						}
					}

					data[x+y*ipr] = gs;
				}
			}
		}catch(Exception ex) { System.out.printf("CORE [Model.Lib  Icons] Failed to load icons from %s\n", filename); }

	}
	
	public GSnip byEntity(Entity e) {
		return data[1]; // TODO real specification via "e instaceof EntityPlayer,EntityProjectile,EntityWuteva"
	}
	
	public GSnip byBlock(Block b) {
		return data[b.ordinal()];
	}
	
	public GSnip byIndex(int index) {
		if (index < 0 || index >= ipr*ipr) return data[0];
		return data[index];
	}
}
