package model;

import java.awt.image.BufferedImage;
import java.io.*;
import java.util.HashMap;
import java.util.List;
import java.util.LinkedList;
import java.util.Vector;

import javax.imageio.ImageIO;

import model.Inventory;
import model.pixies.Bullet;
import model.pixies.Dirt;
import model.pixies.Monster;
import model.pixies.Pixie;
import model.pixies.Player;
import model.pixies.Stone;

import view.Compiz;
import view.GraphicsEngine;
import view.Snippet;
import view.GSnip;
import view.View;
import view.gui.WindowManager;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.Stack;
import java.util.Vector;

public class Model {
	private Pixie[][] map, setmap;
	private int width, height;
	
	public Model(int mapsizex, int mapsizey) {
		width = mapsizex;
		height = mapsizey;
		propertifies     = new HashMap<String, Object>(100);
		map              = new Pixie[mapsizex][mapsizey];
		setmap           = new Pixie[mapsizex][mapsizey];
		enten            = new LinkedList<Pixie>();
		compizsnippets   = new LinkedList<Snippet>();
		wm               = new WindowManager();
		
		world            = new World();
		
		BufferedImage img = null;
		try {
			//img = ImageIO.read(new File("C:/users/lk/worldfix_map_110529.bmp"));
			img = ImageIO.read(new File(new File(".").getCanonicalPath() + "/worldfix_map_110529.bmp"));
			
			for (int x=0; x<img.getWidth(); x++) {
				for (int y=0; y<img.getHeight(); y++) {
					//System.out.println(img.getRGB(x, y));
					if (img.getRGB(x, y) != -1) {
						Pixie p = new Pixie(Pixie.Type.STD);
						world.set(x,y, (short)1);
						p.x = x;
						p.y = y;
					}
				}
			}
		} catch (Exception ex) { System.out.println("Model.this(): couldnt load map"); }
		
		player = new Player(); 
		player.x = mapsizex/2;
		player.y = mapsizey/2;
		player.getInvPalette().get(1).push(new Bullet());
		player.getInvPalette().get(1).push(new Bullet());
		player.getInvPalette().get(1).push(new Bullet());
		player.getInvPalette().get(4).push(new Bullet());
		
		// <custom>
		Monster monster = new Monster(Monster.Type.STD);
		        monster.x = 100;
		        monster.y = 100;
		entenAdd(monster);
		
		//Spawner s = new Spawner(new Water());
		//        s.x = mapsizex/7;
		//        s.y = mapsizey/3;
		//entenAdd(s);
		// </custom>
		
		termtext = new Vector<String>();
	}
	
	/**e.g. "bobs save"*/
	public void save(String savename) {
		try {/*
			FileOutputStream fout = new FileOutputStream(savename+".sav");
			ObjectOutputStream oos = new ObjectOutputStream(fout);
			oos.writeObject(this);
			oos.close();*/
			
			FileWriter fw = new FileWriter(savename+".sav");
			BufferedWriter out = new BufferedWriter(fw);
			
			for (int x=0; x<width; x++) {
				for (int y=0; y<height; y++) {
					Pixie p = get(x,y);
					if (p==null) { out.write(" "); continue; }
					System.out.println(p.toString());
					out.write(p.toString());
				}
				out.write('\n');
			}
			
			// end of map data
			out.write('\n');
			out.write('\n');
			
			for (Pixie p : enten) {
				out.write(p.toString());
			}
			
			out.write("\n");
			
			out.close();
		} catch (Exception e) { return; }
	}
	
	World world;
	public World getWorld() { return world; }
	
	// MG: michal gamrat && maze generation
	int roomsInLine = 19;
	int roomsCount = roomsInLine * roomsInLine;
	Room[][] rooms;
	Stack<Point> recentRooms;
	Point currentRoomCoord;

	public void createMaze() {

		currentRoomCoord = new Point(0, 0);

		int x, y;

		rooms = new Room[roomsInLine][roomsInLine];

		for(x=0; x<roomsInLine; x++){
			for(y=0; y<roomsInLine; y++){
				rooms[x][y] = new Room();    
			}   
		}


		recentRooms = new Stack<Point>();

		this.goToNextRoom();

		while(recentRooms.empty() == false){
			this.goToNextRoom();
		} 

		int roomWidth = width / roomsInLine;
		int roomHeight = height / roomsInLine;

		int rx, ry, x_offset, y_offset;

		for(y=0; y<roomsInLine; y++){
			for(x=0; x<roomsInLine; x++){
				//System.out.print(rooms[y][x].toString());

				y_offset = y * roomHeight;
				x_offset = x * roomWidth;

				Room r = rooms[y][x];
				Pixie p;

				for(ry=0; ry<roomHeight; ry++){
					for(rx=0; rx<roomWidth; rx++){
						if(ry < 3 && r.n || ry > roomHeight-3 && r.s || rx<3 && r.w || rx>roomWidth-3 && r.e ){      
							p = new Pixie(Pixie.Type.STD);
							this.set(rx + x_offset, ry + y_offset, p);
							p.x = rx + x_offset;
							p.y = ry + y_offset;
						}else{       
							map[rx + x_offset][ry + y_offset] = null;
							this.set(rx + x_offset, ry + y_offset, null);      
						}

					}
				}    

			}
			//System.out.println();
		}


	}

	private Set getRooms(){

		Set r = new HashSet();

		if(currentRoomCoord.y > 0 && rooms[(int) currentRoomCoord.y - 1][(int) currentRoomCoord.x].visited == false){
			r.add(1);
		}

		if(currentRoomCoord.y < roomsInLine - 1 && rooms[(int) currentRoomCoord.y + 1][(int) currentRoomCoord.x].visited == false){
			r.add(2);
		}

		if(currentRoomCoord.x > 0 && rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x - 1].visited == false){
			r.add(3);
		}

		if(currentRoomCoord.x < roomsInLine - 1 && rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x + 1].visited == false){
			r.add(4);
		}

		return r;

	}

	private void goToPrevRoom(){

		Point p = recentRooms.pop();
		currentRoomCoord.x = p.x;
		currentRoomCoord.y = p.y;

	}

	private void goToNextRoom(){

		//System.out.println("Current room: "+currentRoom.toString());

		Set r = this.getRooms();

		if(r.isEmpty()){
			goToPrevRoom();
			return;
		}

		recentRooms.push(new Point(currentRoomCoord.x, currentRoomCoord.y));

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

		Random randomGenerator = new Random();  
		int randomInt = randomGenerator.nextInt(r.size());  

		int dir = (Integer)r.toArray()[randomInt];

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

		switch(dir){
		case 1:   
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].n = false;
			currentRoomCoord.y -= 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].s = false;
			break;
		case 2:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].s = false;
			currentRoomCoord.y += 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].n = false;
			break;
		case 3:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].w = false;
			currentRoomCoord.x -= 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].e = false;
			break;
		case 4:
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].e = false;
			currentRoomCoord.x += 1;
			rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].w = false;
			break;
		}

		rooms[(int) currentRoomCoord.y][(int) currentRoomCoord.x].visited = true;

	}
	
	public GSnip getImg(String fortype) {
		
		try {
			BufferedImage img = ImageIO.read(new File(new File(".").getCanonicalPath()+"/"+fortype+".bmp"));
		} catch (IOException e) {
			System.out.println("[model.getImg(..)] Image not found for type \""+fortype+"\"");
			return null;
		}

		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////yay/////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		////////////////////////////////////////////////////
		
		return null;
	}
	
	// PROCESSING
	public boolean isOutSideMap(int x, int y) { // THAT IS NOT REDERING CANVAS!!!
		if (x<0 || y<0 || x>= width || y>= height) return true;
		return false;
	}
	public boolean isOutSideMap(float x, float y) { // THAT IS NOT REDERING CANVAS!!!
		if (x<0 || y<0 || x>= width || y>= height) return true;
		return false;
	}
	
	public Pixie[] raytracePixies(float x1, float y1, float x2, float y2) {
		float len = (float) Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
		if ( len == 0 ) {
			//TODO: Make this function stop if this happens.
			return null;
		}

		float addx = (x2 - x1)/len;
		float addy = (y2 - y1)/len;

		while (((int) x1 != (int) x2 || (int) y1 != (int) y2) && (addx < 0 ? x1 >= x2 : x1 <= x2) && (addy < 0 ? y1 >= y2 : y1 <= y2)) {
			x1 += addx;
			y1 += addy;

			Pixie p = get(Math.round(x1), Math.round(y1));
			if (p == null) continue; // treat null as empty
			if (p.getT() == Pixie.Type.NULL) continue;
			//more emptiness conditions

			//none of the emptiness conditions true. HEAVY PIXELS INCOMMING
			Pixie[] ret = new Pixie[2];
			Pixie prev = get(Math.round(x1 - addx), Math.round(y1 - addy));
			ret[1] = p; // the wall
			if (prev != null) ret[0] = prev;
			else {
				ret[0] = new Pixie(Pixie.Type.COORDS); // yay
				ret[0].x = x1-addx;
				ret[0].y = y1-addy;
			}
			return ret;
		}

		return null;
		
		/*
		float xd=x2-x1,yd=y2-y1;
		float xs=0,ys=0;
		if (xd != 0) {
			ys = yd/xd;
		}
		if (yd != 0) {
			xs = xd/yd;
		}
		boolean cont = true;
		float x=x1, y=y1;
		
		while (cont) {
			//if (x<x2+0.2 && x>x2-0.2)
			if (x > xd || y > yd) break; // THIS line isnt working
			
			x += xs; // advance a step
			y += ys;
			
			Pixie p = get(Math.round(x), Math.round(y));
			if (p      == null            ) continue; // treat null as empty
			if (p.type == Pixie.Type.NULL ) continue;
			// add more emptyness conditions here
			
			Pixie[] ret = new Pixie[2];
			ret[1] = p; // the thing we just hit on. (notices p is not NULL)
			ret[0] = get(Math.round(x-xs), Math.round(y-ys));
			return ret;
		}
		
		return null;
		*/
	}
	public Point[] raytracePoints(float x1, float y1, float x2, float y2) {
		float len = (float) Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
		if ( len == 0 ) {
			//TODO: Make this function stop if this happens.
			return null;
		}

		float addx = (x2 - x1)/len;
		float addy = (y2 - y1)/len;

		while (((int) x1 != (int) x2 || (int) y1 != (int) y2) && (addx < 0 ? x1 >= x2 : x1 <= x2) && (addy < 0 ? y1 >= y2 : y1 <= y2)) {
			x1 += addx;
			y1 += addy;

			Pixie p = get(Math.round(x1), Math.round(y1));
			if (p == null) continue; // treat null as empty
			if (p.getT() == Pixie.Type.NULL) continue;
			//more emptiness conditions

			//none of the emptiness conditions true. HEAVY PIXELS INCOMMING
			Point[] ret = new Point[2];
			ret[1] = new Point(p.x, p.y); // the wall
			ret[0] = new Point(x1-addx, y1-addy);
			return ret;
		}

		return null;
	}
	
	// PROPERTIFY
	private HashMap<String, Object> propertifies;
	public void propset(String key, Object value) { propertifies.put(key, value); }
	public Object prop(String key) { return propertifies.get(key); }
	
	// VARIOUS RESSOURCES
	
	private WindowManager wm;
	public WindowManager getWM() { return wm; }
	
	// Map scrolling
	float offx, offy; // how many PIXELS (px, not pixies) offset from zero!!!
	float noffx, noffy;
	public final static int zoom = 16; // bit of useless... who cares
	public synchronized void scrollToCentrify(float x, float y) {
		noffx = (int)(x-(View.WIDTH /zoom/2)); // TODO centrify realy
		noffy = (int)(y-(View.HEIGHT/zoom/2));
	}
	public synchronized void scrollTo(float x, float y) {
		noffx = x;
		noffy = y;
	}
	public float scrollX() { return offx; }
	public float scrollY() { return offy; }
	/**Do not use. /lk*/
	public void setScrolls() { this.offx = noffx; this.offy = noffy; }
	
	// Compiz
	private List<Snippet> compizsnippets;
	private Compiz compiz;
	
	// TODO buggy (lazy initialisation of compiz)
	public Compiz compizEnsure(Compiz cpz) {
		if (this.compiz != null) this.compiz = cpz;
		return compiz;
	}
	public Compiz compizEnsure(GraphicsEngine ge) {
		if (this.compiz == null) return (this.compiz = new Compiz(ge));
		return compiz;
	}

	/*
	 * If you arent sure if compiz yet has been created. you might use compizEnsure (the one taking GraphicsEngine).
	 * They're very handy. [[[> WARNING: as of my new Standard v0.11R10IN this is deprecated. init*() are now in use! <]]] 
	 * @return Compiz. NULL otherwise. (otherwise use compizEnsure(..));
	 */
	public Compiz compizGet() { return compiz; }
	public List<Snippet> compizSnippetsGet() {
		return compizsnippets;
	}
	public void compizSnippetsAdd(Snippet snip) {
		compizsnippets.add(snip);
	}
	public void compizSnippetsRemove(Snippet snip) {
		compizsnippets.remove(snip);
	}
	
	// pausing
	private boolean paused = false;
	
	public void pause(boolean p) { this.paused = p; }
	public boolean pause() { return paused; }
	
	// data
	private Player player;
	private List<Pixie> enten;
	
	public synchronized Pixie get(int x, int y) {
		if (x<0 || x>=map.length || y<0 || y>=map[x].length) { return null; } // XXX buggy
		//if (map[x][y] == null) map[x][y] = new Pixie(0);
		return map[x][y];
	}
	public synchronized void set(int x, int y, Pixie pix) {
		if (x<0 || x>=map.length || y<0 || y>=map[x].length) return;
		setmap[x][y] = pix;
	}
	public synchronized void set(float x, float y, Pixie pix) {
		if (x<0 || x>=map.length || y<0 || y>=map[Math.round(x)].length) return;
		setmap[Math.round(x)][Math.round(y)] = pix;
		pix.x = x;
		pix.y = y;
	}
	public synchronized void setMap() {
		for (int x=0; x<map.length; x++) {
			for (int y=0; y<map[x].length; y++) {
				map[x][y] = setmap[x][y];
			}
		}
	}
	public Player getPlayer() { return player; }
	public List<Pixie> entenGet() { return enten; }
	public int entenAdd(Pixie ente) { enten.add(ente); return enten.size()-1; }
	public void entenRemove(Pixie ente) { enten.remove(ente); }
	public void entenRemove(int entex) { enten.remove(entex); }
	
	public Inventory playerInvGet() { return player.getInv(); }
	public Inventory playerInvPaletteGet() { return player.getInvPalette(); }
	public Inventory playerInvAromorGet() { return player.getInvArmor(); }
	
	// drawing on the map with pixies (TEMPORARY TODO)
	public static final Pixie paintcopythis1 = new Stone();
	public static final Pixie paintcopythis2 = new Dirt();
	
	// general
	public int getWidth() {
		return width;
	}
	public int getHeight() {
		return height;
	}

	// terminal (WIP)
	private Vector<String> termtext;
	private boolean termextend = false; // fullscreen terminal
	
	public Vector<String> termGetText() { return termtext; }
	public void termPost(String text) { termtext.add(text); if (termtext.size() < 6) return; termtext.remove(0); }
	public String termLast(int neg) { int npos=termtext.size()-neg-1; if (npos<0 || npos>=termtext.size()) return null; return termtext.get(npos); }
	public boolean termExtend() { return termextend; }
	public void termExtend(boolean termextend) { this.termextend = termextend; }
	
	// form managment (see getWM() and WindowManager in view.gui )
	private boolean useforms = false;

	public boolean useForms() {
		return useforms;
	}
	public void useForms(boolean useforms) {
		this.useforms = useforms;
	}
	
}
