package model;

import java.util.LinkedList;
import java.util.List;

public class World {
	List<Chunk> chunks; // all the chunks
	Entity[] entities; // global entities storer
	
	public World() {
		chunks = new LinkedList<Chunk>();
		entities = new Entity[65536];
	}
	
	public long entityallocate(Entity ente) {
		for (int i=0; i<entities.length; i++) {
			if (entities[i] == null) {
				entities[i] = ente;
				return i;
			}
		}
		return -1;
	}
	public void entitykill(long eid) {
		if (eid>=0 && eid<entities.length)  {
			Entity e = entities[(int) eid];
			if (e == null) return;
			
			entities[(int) eid] = null;
			e.getChunk().entityrem(eid);
		}
	}
	
	public short get(int x, int y) {
		Chunk c = getChunkAt(x,y);
		if (c != null) { return c.get(x-c.x, y-c.y); }
		return 0;
	}
	public void set(int x, int y, short datatype) { Chunk c = ensureChunkAt(x,y); c.set(c.x-x, c.y-y, datatype); }
	
	public Chunk ensureChunkAt(int x, int y) {
		for (Chunk c : chunks) {
			if (x>=c.x && y>=c.y && x<c.x && y<c.y) {
				return c;
			}
		}
		Chunk c = new Chunk(this, x-(x%Chunk.cs), y-(y%Chunk.cs));
		
		return c;
	}
	
	public Chunk getChunkAt(int x, int y) {
		for (Chunk c : chunks) {
			if (x>=c.x && y>=c.y && x<c.x && y<c.y) {
				return c;
			}
		}
		return null;
	}
}




