package model.pixies;

import java.awt.Color;

import model.Model;
import model.Point;

import view.GraphicsEngine;

public class Acid extends Material {
	
	public Acid() {
		super(Material.Type.Acid);
	}
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	public String getShortIdentifier() { return "a"; }
	
	public String toString() {
		String ret = "a";
		
		return ret;
	}
	
	@Override
	public void update(Model m, float delta) {
		final float fall = 1;

		m.set(getX(), getY(), null);
		float px=x, py=y;
		
		Point[] ps = m.raytracePoints(x, y, x, y+fall);
		if (ps == null) {
			y+=fall;
		} else {
			Point[] psl, psr;
			psr = m.raytracePoints(x, y, x+1, y); // right
			psl = m.raytracePoints(x, y, x-1, y); // left
			
			if (psl == null) {
				x+=1;
			} else
			if (psr == null) {
				x-=1;
			} else {
				//x=px;
				//y=py;
				
				/*
				if (psr[0] != null) {
					
				} else
				if (psl[0] != null) {
					
				} else {
					// give up
					x=px;
				}
				
				*/
			}
		}
		
		/*
		if (m.get( (int)x, (int)y+1 ) == null) {
			y+=fall;
		} else {
			if (m.get( (int)x+1, (int)y )==null) x+=1.37f;
			else if (m.get( (int)x-1, (int)y )==null) x-=1.37f;
		}
		*/
		
		m.set(getX(), getY(), this);
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), new Color(255, 10, 255));
	}
	
	
	
}
