package model.pixies;

import java.awt.Color;

import model.Model;
import model.Point;

import view.Compiz;
import view.GraphicsEngine;
import view.GSnip;

public class Bullet extends Thing {
	public static final String myname = "Bullet";
	
	// hehehe
	public enum Type {
		ERROR,
		STD,
		Standard, // TODO usual yellow gun bullet...
		Laser, // TODO same as above, red, more power
		Bomb, // TODO .... puff
		Creeper, // TODO ....
	} protected Type type;
	public static String type2str(Type type) {
		switch(type) {
		case STD: return "STD";
		case Standard: return "Standard";
		case Laser: return "Laser";
		case Bomb: return "Bomb";
		case Creeper: return "Creeper";
		}
		return "ERROR";
	}
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return type2str(type); }
	public String getLongType() { return super.getLongType() + "." + type2str(type); }
	public String getShortIdentifier() { return "b"; }
	
	public String toString() {
		String ret = "b[";
		ret += dir + "|";
		ret += speed;
		ret += "]";
		
		return ret;
	}
	
	@Override
	public void update(Model m, float delta) {
		// super.update(m);
		
		if (m.isOutSideMap(x, y)) m.entenRemove(this);
		
		//System.out.println("tmp 110616: " + (0.1-Math.random()*0.2));
		
		dir += 0.015-(Math.random()*0.03);
		speed *= 1.07;
		
		float xp=x, yp=y;
		
		x += (float)(Math.cos(dir)*speed*delta);
		y += (float)(Math.sin(dir)*speed*delta);
		//System.out.printf("[chaos] dir:%f | speed:%f | delta:%f\n", dir, speed, delta);
		

		Point[] ps = m.raytracePoints(xp,yp, x,y);
		if (ps != null) {
			// delete some particles (BUFF)
			int ix=(int)ps[1].x;
			int iy=(int)ps[1].y;

			m.set(ix  , iy  , null);
			m.set(ix-1, iy  , null);
			m.set(ix+1, iy  , null);
			m.set(ix  , iy-1, null);
			m.set(ix  , iy+1, null);
			m.entenRemove(this);
		}
		
		/*
		glow.x = (int)x-30;
		glow.y = (int)y-30;
		glow.requestRemap();
		*/
		
		
		
		//m.set(getX(), getY(), this);
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), Color.yellow);
		//ge.getModel().termPost("Bullet has been rendered! ("+x+","+y+")"); // model access is dirty. (gol.Controller)
	}
	
	public Bullet() { // simplification
		this(Type.STD); // default choice
	}
	public Bullet(Type type) { // main constructor
		super(Thing.Type.Bullet);
		this.type = type;
	} // expensions following
	public Bullet(Type type, float dir) {
		this(type);
		this.dir = (float) (dir+Math.random());
	}
	public Bullet(Type type, float dir, float speed) {
		this(type, dir);
		this.speed = (speed*10);
	}
	
}










