package model.pixies;

import java.awt.Color;

import model.Model;
import model.Point;

import view.GraphicsEngine;

public class Laser extends Bullet {
	public static final String myname = "Laser";
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return "("+type2str(type)+")"; }
	public String getLongType() { return super.getLongType() + ".(" + type2str(type) + ")"; }
	public String getShortIdentifier() { return "!"; }
	
	@Override
	public void update(Model m, float delta) {
		// super.update(m);
		
		if (m.isOutSideMap(x, y)) m.entenRemove(this);
		
		float xp=x, yp=y;
		
		x += (float)(Math.cos(dir)*speed*delta);
		y += (float)(Math.sin(dir)*speed*delta);
		//System.out.printf("[chaos] dir:%f | speed:%f | delta:%f\n", dir, speed, delta);
		

		Point[] ps = m.raytracePoints(xp,yp, x,y);
		if (ps == null) return;
		else {
			// delete some particles
			int ix=(int)ps[1].x;
			int iy=(int)ps[1].y;

			m.set(ix  , iy  , null);
			m.set(ix-1, iy  , null);
			m.set(ix+1, iy  , null);
			m.set(ix  , iy-1, null);
			m.set(ix  , iy+1, null);
			m.entenRemove(this);
		}
		
		//m.set(getX(), getY(), this);
	}
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.set(getX(), getY(), Color.red);
		//ge.getModel().termPost("Bullet has been rendered! ("+x+","+y+")"); // model access is dirty. (gol.Controller)
	}
	
	public Laser() {
		super(Bullet.Type.Laser);
		dir = 0;
		speed = 3;
	}
	public Laser(float dir) {
		this();
		this.dir = dir;
		speed = 3;
	}
	public Laser(float dir, float speed) {
		this(dir);
		this.speed = speed;
	}
	
}