package model.pixies;

import java.awt.Color;

import model.Model;

import view.GraphicsEngine;

public class Monster extends Actor {
	public static final String myname = "Monster";
	private float speed = 1;
	private float dir = 30;
	
	public enum Type {
		ERROR,
		STD, // do not use this in combination with monsters unless you want
		Zombie, // WIP
		Creeper, // TODO
	}
	protected Type type;
	
	public static String type2str(Type type) {
		switch (type) {
		case STD: return "STD";
		case Zombie: return "Zombie";
		case Creeper: return "Creeper";
		}
		return "ERROR";
	}
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return type2str(type); }
	public String getLongType() { return super.getLongType() + "." + type2str(type); }
	
	@Override
	public void render(GraphicsEngine ge) {
		ge.drawChar(getX()-3, getY()-4, GraphicsEngine.UNHAPPY, Color.red, 1);
	}
	
	public void randomize() {
		dir = (float) Math.toRadians(Math.random()*360);
		speed = (float) (Math.random()*200);
	}
	
	/**
	 * 
	 * @param with
	 * @return 1:"with" has won; 0:_this_ won
	 */
	public int fight(Actor with) {
		
		
		
		return 0;
	}
	
	@Override
	public void update(Model m, float delta) {
		float px=x, py=y;
		
		x += (float)(Math.cos(dir)*speed*delta);
		y += (float)(Math.sin(dir)*speed*delta);
		
		if (m.raytracePoints(px, py, x, y) != null) {
			x=px;
			y=py;
			randomize();
		}
		
		if (Math.random() < 0.01) {
			randomize();
			m.termPost("Virtual Hell: Randomized the Monster.");
		}
		
		
	}
	
	public Monster(Type type) {
		super(Actor.Type.Monster);
		this.type = type;
	}

}
