package model.pixies;

public class Thing extends Actor {
	public static final String myname = "Thing";
	
	public enum Type {
		NULL,
		ERROR,
		STD,
		
		Bullet, // Bullet
		Spawner, // Spawner
	}
	
	public float speed;
	public float dir;
	protected Type type;
	
	public static String type2str(Type type) {
		switch (type) {
		case NULL: return "NULL";
		case STD: return "STD";
		case Bullet: return "Bullet";
		case Spawner: return "Spawner";
		}
		return "ERROR";
	}
	
	public static String getName() { return myname; }
	public String getLongName() { return super.getLongName() + "." + getName(); }
	public String getType() { return type2str(type); }
	public String getLongType() { return super.getLongType() + "." + type2str(type); }

	public String toString() {
		String ret = "b[";
		ret += dir + "|";
		ret += speed;
		ret += "]";
		
		return ret;
	}
	
	public Thing(Type type) {
		super(Actor.Type.Thing);
		this.type = type;
		this.speed = 1;
	}
	public Thing(Type type, float speed) {
		this(type);
		this.speed = speed;
	}

}
