package view;

import java.awt.Color;

import model.Entity;
import model.EntityAnimation;
import model.Model;

public abstract class RenderAnimation {
	private static final int zoom = Model.zoom;
	// private static final int cs = Chunk.cs;
	private static Model model;
	public static void initModel(Model model) {
		RenderAnimation.model = model;
	}
	private static int offx() {
		if (model == null) {
			return 0;
		}
		return model.scrollX();
	}
	private static int offy() {
		if (model == null) {
			return 0;
		}
		return model.scrollY();
	}
	
	public static final void render(EntityAnimation wut, GraphicsEngine ge) {
		if (wut instanceof EntityAnimation) renderAnimation(wut,ge);
		// else if...
	}
	
	public static void renderAnimation(EntityAnimation wut, GraphicsEngine ge) { }
	
	
	private static void simpleRender(Entity wut, GraphicsEngine ge, Color c) {
		simpleFill(ge, (int) ((wut.getX() - offx()) * zoom),
				(int) ((wut.getY() - offy()) * zoom), c);
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c) {
		simpleFill(ge, x, y, c, zoom, zoom);
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c,
			int xs, int ys) {
		for (int mx = 0; mx < xs; mx++) {
			for (int my = 0; my < ys; my++) {
				ge.seta(mx + x, my + y, c);
			}
		}
	}
}
