package view;

import java.awt.Color;

import model.BlockX;
import model.Block;
import model.Chunk;
import model.Entity;
import model.Model;

// useful: wut.getOrig().getColor()

/**
 * x,y are coords on the canvas. thx
 * 
 */
public abstract class RenderBlock {
	// private static final int cs = Chunk.cs;
	private static final int zoom = Model.zoom;

	public static void render(Block wut, GraphicsEngine ge, int x, int y) {
		switch (wut) {
		case air: /* renderAir(wut, ge, x, y); */
			break;

		case stone:
			renderStone(wut, ge, x, y);
			break;

		case dirt:
			renderDirt(wut, ge, x, y);
			break;

		case player:
			renderPlayer(wut, ge, x, y);
			break;

		case torch:
			renderTorch(wut, ge, x, y);
			break;
		}
	}

	private static void renderTorch(Block wut, GraphicsEngine ge, int x, int y) {
		simpleRender(wut, ge, x, y, Color.yellow.brighter());
	}

	private static void renderPlayer(Block wut, GraphicsEngine ge, int x, int y) {
		simpleRender(wut, ge, x, y, Color.white);
	}

	private static void renderDirt(Block wut, GraphicsEngine ge, int x, int y) {
		simpleFill(ge, new Color(255, 128, 20), x, y);
	}

	private static void renderStone(Block wut, GraphicsEngine ge, int x, int y) {
		simpleFill(ge, Color.gray, x, y);
	}

	private static void renderAir(Block wut, GraphicsEngine ge, int x, int y) {
	}

	private static void simpleRender(Block wut, GraphicsEngine ge, int x,
			int y, Color c) {
		simpleFill(ge, c, (int) (x + (wut.insl * zoom)),
				(int) (y + (wut.inst * zoom)), (int) (zoom - wut.insr * zoom),
				(int) (zoom - wut.insb * zoom));
	}

	private static void simpleFill(GraphicsEngine ge, Color cl, int x, int y,
			int xs, int ys) {
		for (int mx = 0; mx < xs; mx++) {
			for (int my = 0; my < ys; my++) {
				ge.set(mx + x, my + y, cl);
			}
		}

	}

	private static void simpleFill(GraphicsEngine ge, Color cl, int x, int y) {
		simpleFill(ge, cl, x, y, zoom, zoom);
	}

}
