package view;

import java.awt.Color;

import model.Block;
import model.BlockX;
import model.Chunk;
import model.Model;
import model.World;

@SuppressWarnings("serial")
public class View extends GraphicsEngine implements GraphicsEngine.KeyL, GraphicsEngine.MouseL, GraphicsEngine.MouseMotionL {
	
	public View(Model model) {
		super(model);
		this.model = model;
		//addMouseL(this);
		//addMouseMotionL(this);
		//addKeyL(this);
		
		model.getWM().initGE(this);
	}
	
	@Override
	protected void onRender() {
		/* 110627: switching to scaled big blocks. see below
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				Pixie pix = model.getWorld().get(x, y);
				if (pix == null) { continue; }
				pix.render(this);
			}
		}*/
		
		World tmpworld = model.getWorld();
		
		for (int x=0; x<WIDTH/Model.zoom+1; x++) {
			for (int y=0; y<HEIGHT/Model.zoom+1; y++) {
				//Chunk chk = model.getWorld().getChunkAt((int)(x+model.scrollX()), (int)(y+model.scrollY()));
				RenderBlock.render(tmpworld.get(x, y), this, x*Model.zoom, y*Model.zoom);
			}
		}
		
		
		/*
		for (int x=0; x<WIDTH/Model.zoom+1; x++) {
			for (int y=0; y<HEIGHT/Model.zoom+1; y++) {
				Block block = model.getWorld().get((int)(x+model.scrollX()), (int)(y+model.scrollY()));
				//Pixie p = model.get(x+(int)(Math.floor(model.scrollX()/Model.zoom)),y+(int)(Math.floor(model.scrollY()/Model.zoom)));
				System.out.printf("%f ... %f\n", x+(Math.floor(model.scrollX())), y+(Math.floor(model.scrollY())));
				if (block == null) continue;
				
				for (int cx=0; cx<Model.zoom; cx++) {
					for (int cy=0; cy<Model.zoom; cy++) {
						set((int)(x*Model.zoom +cx), (int)(y*Model.zoom+cy-(model.scrollY()%Model.zoom)), block.getColor());
					}
				}
				
			}
		} */
		
		//console TEXT
		int offs = 1;
		if (!model.termExtend()) {
			for (int i=4; i>=0; i--) { // 3 entries (4-1)
				String str = model.termLast(i); if (str == null) continue;
				text(10, offs+2, str, Color.yellow, 1);
				offs+=7+2;
			}
		} else {
			for (int i=20; i>=0; i--) {
				String str = model.termLast(i); if (str == null) continue;
				text(10, offs+2, str, Color.yellow, 1);
				offs+=7+2;
			}
			
		}
		
		/* 110629: commented out: minecraftification
		// default UI (palette of player)
		Inventory palette = model.playerInvPaletteGet();
		if (palette == null) { System.out.println("[view.View.onRender():default UI] Palette null!"); }
		// draw background ( horizontal space needed: (24+2)*8 +2 = 210
		for (int x=WIDTH/2-105; x<WIDTH/2+105; x++) {
			for (int y=HEIGHT-27; y<HEIGHT; y++) {
				set(x,y,Color.GRAY.brighter());
			}
		}
		final int shiftstep = 24; // take 2 as space between each element (on x axis)
		int shift = 0;
		for (int i=0; i<8; i++) {
			shift+=2;
			
			if (palette.get(i) == null || palette.get(i).type == "NULL" || palette.get(i).quantity <= 0 || palette.get(i).items.length <= 0) {
				for (int x=0; x<24; x++) {
					for (int y=0; y<24; y++) {
						set(x+shift+(WIDTH/2-105), y+2+(HEIGHT-27), Color.black.brighter());
					}
				}
				shift+=shiftstep;
				continue;
			}
			
			GSnip gs = palette.get(i).getImg();
			if (gs == null) continue;
			
			for (int x=0; x<gs.xlen(); x++) {
				for (int y=0; y<gs.ylen(); y++) {
					Color c = gs.get(x, y);
					if (c == null) continue;
					set(x+shift+(WIDTH/2-105), y+2+(HEIGHT-27), c);
				}
			}
			
			String quantity = ""+palette.get(i).quantity;
			int len = GraphicsEngine.textlen(quantity, 1);
			text(shift+(WIDTH/2-105)+(Math.abs(24-len)), 2+(HEIGHT-27)+(Math.abs(24-8)), quantity, Color.white, 1); // worked on first go. might be buggy
			
			shift += shiftstep;
		}
		*/
		
		
		// player..
		for (int cx=0; cx<Model.zoom; cx++) {
			for (int cy=0; cy<Model.zoom; cy++) {
				set(WIDTH/2+cx-(Model.zoom/2), HEIGHT/2+cy-(Model.zoom/2), Color.white);
			}
		}
		
		// COMPIZ
		// if you uncomment the following, you can get ultimate light effects!
		// model.compizGet().remap(); // now it automatically remaps, only if needed
		//model.compizGet().blend();
		
		
		if (model.useForms()) model.getWM().render();
		/*
		// FORMS GUI
		if (!model.useForms()) return;
		Stack<Form> fstack = model.formGetStack();
		
		// darken pre
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				set(x,y, get(x,y).darker().darker());
			}
		}
		
		// in case of empty
		if (fstack.isEmpty()) {
			int notextlen = textLen("No forms to display", 2);
			text(WIDTH/2-(notextlen/2),50,"No forms to display", new Color(64, 60, 60));
			drawChar(WIDTH/4+4, 50+7*4+3, UNHAPPY, new Color(70, 50, 50), 4);
			return; // !
		}
		
		// ((print all but last))
		for (int i=0; i<fstack.size(); i++) {
			GSnip fcanvas = fstack.get(i).render(this); // form's canvas
			if (fcanvas == null) continue;
			
			int posx = fcanvas.xpos();
			int posy = fcanvas.ypos();
			int lenx = fcanvas.xlen();
			int leny = fcanvas.ylen();
			
			// ==== DRAW FRAME ====
			
			// left & right border
			for (int y=posy-Form.frametop; y<posy+leny+Form.frameborders; y++) {
				set(posx-1, y, Color.white);
			}
			for (int y=posy-Form.frametop; y<posy+leny+Form.frameborders; y++) {
				set(posx+lenx, y, Color.white);
			}
			
		}
		*/
		
		/* old code 110616
		// darken finial
		for (int x=0; x<model.getWidth(); x++) {
			for (int y=0; y<model.getHeight(); y++) {
				set(x,y, get(x,y).darker());
			}
		}
		
		// print last
		fstack.get(fstack.size()-1).render(this);
		*/
	}
	
	@Override
	protected void onUpdate() {
		model.setScrolls();
		if (model.pause()) return;
		
		invokeFrameUpdateListeners();
	}

	
	
	public boolean mouseMoved(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseMoved(x, y);
		} else {
			return false; // TODO
		}
	}
	public boolean mouseDragged(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDragged(x, y);
		} else {
			return false; // TODO FIXME XXX (and all others). "event waterfall". i.e. call next one if this one hasnt consumed it
		}
	}
	public boolean mouseClicked(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseClicked(x, y);
		} else {
			return false; // TODO
		}
	}
	public boolean keyTyped(char letter) {
		if (model.useForms()) {
			return model.getWM().keyTyped(letter);
		} else {
			return false;
		}
	}
	public boolean keyPressed(int code) {
		if (model.useForms()) {
			return model.getWM().keyPressed(code);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseDown(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDown(x,y);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseUp(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseUp(x,y);
		} else {
			return false; // TODO others also want some events
		}
	}

}








