package view;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import model.Block;
import model.BlockX;
import model.Chunk;
import model.Entity;
import model.Inventory;
import model.InventorySlot;
import model.LibIcons;
import model.Model;
import model.World;

import view.gui.*;

@SuppressWarnings("serial")
public class View extends GraphicsEngine implements GraphicsEngine.KeyL,
		GraphicsEngine.MouseL, GraphicsEngine.MouseMotionL {

	// DisplayInventory paletterenderer;

	public View(Model model) {
		super(model);
		this.model = model;
		RenderEntity.initModel(model);
		// addMouseL(this);
		// addMouseMotionL(this);
		// addKeyL(this);

		model.getWM().initGE(this);

		// paletterenderer = new
		// DisplayInventory(model.getPlayer().getPalette(), 8);
		// paletterenderer.initSize(LibIcons.iconsize+4, LibIcons.iconsize+4);
	}

	@Override
	protected void onRender() {
		World tmpworld = model.getWorld();
		for (int x = 0; x < WIDTH / Model.zoom + 1; x++) {
			for (int y = 0; y < HEIGHT / Model.zoom + 1; y++) {
				// Chunk chk =
				// model.getWorld().getChunkAt((int)(x+model.scrollX()),
				// (int)(y+model.scrollY()));
				RenderBlock.render(tmpworld.get((int) (x + model.scrollX()),
						(int) (y + model.scrollY())), this, x * Model.zoom, y
						* Model.zoom);
			}
		}
		for (Entity e : tmpworld.getEntities()) {
			RenderEntity.render(e, this);
		}

		//RenderEntity.render(model.getPlayer(), this);
		model.scrollToCentrify((int) (model.getPlayer().getX()), (int) (model.getPlayer().getY()));

		// TODO add entity interation
		// int iteratorhandle = world.enterate();
		// Entity e = world.enterateNext();
		// if (e != null) { do something } else {
		// world.deterate(iteratorhandle); break; }
		// no wait, thats not good. must do it chunk oriented: List<Entity>
		// entities = currentchunk.getEntities();

		/*
		 * for (int x=0; x<WIDTH/Model.zoom+1; x++) { for (int y=0;
		 * y<HEIGHT/Model.zoom+1; y++) { Block block =
		 * model.getWorld().get((int)(x+model.scrollX()),
		 * (int)(y+model.scrollY())); //Pixie p =
		 * model.get(x+(int)(Math.floor(model
		 * .scrollX()/Model.zoom)),y+(int)(Math
		 * .floor(model.scrollY()/Model.zoom)));
		 * System.out.printf("%f ... %f\n", x+(Math.floor(model.scrollX())),
		 * y+(Math.floor(model.scrollY()))); if (block == null) continue;
		 * 
		 * for (int cx=0; cx<Model.zoom; cx++) { for (int cy=0; cy<Model.zoom;
		 * cy++) { set((int)(x*Model.zoom +cx),
		 * (int)(y*Model.zoom+cy-(model.scrollY()%Model.zoom)),
		 * block.getColor()); } }
		 * 
		 * } }
		 */

		// console TEXT
		int offs = 1;
		if (!model.termExtend()) {
			for (int i = 4; i >= 0; i--) { // 3 entries (4-1)
				String str = model.termLast(i);

				if (str == null) {
					continue;
				}
				text(10, offs + 2, str, Color.yellow, 1);
				offs += 7 + 2;
			}
		} else {
			for (int i = 20; i >= 0; i--) {
				String str = model.termLast(i);

				if (str == null) {
					continue;
				}
				text(10, offs + 2, str, Color.yellow, 1);
				offs += 7 + 2;
			}

		}

		// model.getPPalette().render(this);


		// === default UI (palette of player)
		Inventory palette = model.getPlayer().getPalette();
		if (palette == null) {
			System.out.println("CORE [view.View onRender() Palette] Palette null!");
		}
		// draw background ( horizontal space needed: (24+2)*8 +2 = 210
		final Color inner=new Color(50, 50, 100, 170), outer=new Color(200, 250, 250, 200);
		Color use;
		final int xf=WIDTH/2-105,xt=WIDTH/2+105, yf=HEIGHT-27,yt=HEIGHT+1; // froms and tos
		for (int x=xf; x<xt; x++) {
			for (int y=yf; y<yt; y++) {
				use = inner;
				if (x==xf || y==yf || x==xt-1 || y==yt-1) use = outer;
				seta(x, y, use);
			}
		}
		final int shiftstep = 24; // take 2 as space between each element (on x axis)
		int shift = 0;
		for (int i = 0; i < 8; i++) {
			shift += 2;
			InventorySlot slot = palette.get(i);
			if (slot == null || slot.isEmpty()) {
				for (int x = 0; x < 24; x++) {
					for (int y = 0; y < 24; y++) {
						seta(x + shift + (WIDTH / 2 - 105), y + 2 + (HEIGHT - 27), new Color(0,0,0,120));
					}
				}
				shift += shiftstep;
				continue;
			}
			GSnip icon = slot.getIcon();
			if (icon == null) {
				System.out.printf("CORE [View onRender: playerpalette] slot#%d's icon is null\n", i);
				continue;
			}
			icon.render(this, shift + (WIDTH / 2 - 105), 2 + HEIGHT - 27, 24, 24);


			String quantity = ""+slot.getQuantity();
			int len = GraphicsEngine.textlen(quantity, 1);
			text(shift+(WIDTH/2-105)+(Math.abs(24-len)), 2+(HEIGHT-27)+(Math.abs(24-8)), quantity, Color.white, 1); // worked on first go. might be buggy

			shift += shiftstep; 
		}

		if (model.useForms()) {
			model.getWM().render();
		}
	}

	@Override
	protected void onUpdate() {
		model.setScrolls();
		if (model.pause()) {
			return;
		}

		invokeFrameUpdateListeners();
	}

	public boolean mouseMoved(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseMoved(x, y);
		} else {
			return false; // TODO
		}
	}

	public boolean mouseDragged(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDragged(x, y);
		} else {
			return false; // TODO FIXME XXX (and all others). "event waterfall".
							// i.e. call next one if this one hasnt consumed it
		}
	}

	public boolean mouseClicked(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseClicked(x, y);
		} else {
			return false; // TODO
		}
	}

	public boolean keyTyped(char letter) {
		if (model.useForms()) {
			return model.getWM().keyTyped(letter);
		} else {
			return false;
		}
	}

	public boolean keyPressed(int code) {
		if (model.useForms()) {
			return model.getWM().keyPressed(code);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseDown(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseDown(x, y);
		} else {
			return false; // TODO others also want some events
		}
	}

	@Override
	public boolean mouseUp(int x, int y) {
		if (model.useForms()) {
			return model.getWM().mouseUp(x, y);
		} else {
			return false; // TODO others also want some events
		}
	}

}
