package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;

public class CheckBox extends Component {
	
	boolean state;
	String text;
	int step; // 0,1,2,3,4,5,6,7 (8 elements)
	// 012
	// 7 3
	// 654
	
	public CheckBox() {
		state = false;
		step = 0;
		
		ys =  7;
		xs = 80;
	}
	
	public int setText(String text) {
		this.text = text;
		return GraphicsEngine.textlen(text, 1) + 10;
	}
	
	public GSnip redraw() {
		step++;
		if (step>7) step=0;
		
		if(xs<1)xs=1; if(ys<1)ys=1;
		GSnip gs = new GSnip(xs, ys);
		
		for (int x=0; x<7; x++) {
			for (int y=0; y<7; y++) {
				gs.setraw(x,y, new Color(40, 170, 70, (int)(Math.random()*70+150)));
			}
		}
		for (int x=1; x<6; x++) {
			for (int y=1; y<6; y++) {
				gs.setraw(x,y, new Color(40, 100, 50, 150));
			}
		}
		
		if (state) {
			int prevstep = step;
			for (int i=0; i<4; i++) {
				step++;
				if (step>7) step = 0;
				switch(step) {
				case 0: gs.set(2+0, 2+0, Color.green); break;
				case 1: gs.set(2+1, 2+0, Color.green); break;
				case 2: gs.set(2+2, 2+0, Color.green); break;
				case 3: gs.set(2+2, 2+1, Color.green); break;
				case 4: gs.set(2+2, 2+2, Color.green); break;
				case 5: gs.set(2+1, 2+2, Color.green); break;
				case 6: gs.set(2+0, 2+2, Color.green); break;
				case 7: gs.set(2+0, 2+1, Color.green); break;
				default: gs.set(3,3, Color.red); break;
				}
			}
			step = prevstep;
		}
		
		GraphicsEngine.gstext(10, 0, text,new Color(40, 255, 40, 230), 1, gs);
		
		return gs;
	}
	
	/**Empty. Overridable. Go wild. */
	protected void oStateChange() { }
	
 	public boolean eventMouseClick(int x, int y) {
		state = !state; // invert/toggle
		oStateChange();
		return true;
	}
	
}
