package view.gui;

import java.awt.Color;
import java.util.List;
import java.util.LinkedList;

import view.GSnip;
import view.GraphicsEngine;

/**This poor thing also has to take over parental forces*/
public class Container extends Component {
	private List<Component> list;
	Component focus;
	
	public Container() {
		list = new LinkedList<Component>();
		focus = null;
	}
	
	public GSnip redraw() {
		GSnip gs = new GSnip(xs, ys);
		
		// TV effect
		final int s = 2; // scale
		for (int x=0; x<gs.xlen()/s+s; x++) {
			for (int y=0; y<gs.ylen()/s+s; y++) {
				//gs.set(x, y, new Color((int)(Math.random()*20f), (int)(Math.random()*50f), (int)(Math.random()*70f)));
				Color c = new Color((int)(Math.random()*7f), (int)(Math.random()*25f), (int)(Math.random()*40f), (int)(Math.random()*20)+230);
				for (int cx=0; cx<s; cx++) {
					for (int cy=0; cy<s; cy++) {
						gs.set(x*s+cx, y*s+cy, c);
					}
				}
			}
		}
		
		// components
		for (Component c : list) {
			c.redraw().drawonto(gs, c.x, c.y);
		}
		
		return gs;
	}
	
	public Component getCompAt(int x, int y) {
		for (Component c : list) {
			if (x>=c.x && x<c.x+c.xs && y>=c.y && y<c.y+c.ys) return c;
		}
		return null;
	}
	
	public Component getFocus() { return focus; }
		
	public void add(Component wut) { list.add(wut); }
	public void remove(Component wut) { list.remove(wut); }
	public void ensure(Component wut) { if (list.contains(wut))return; add(wut); }
	
	public void poke() { for(Component c : list) c.poke(); }
	public void resize(int xs, int ys) { super.resize(xs, ys); }
	public void move(int x, int y) { super.move(x, y); }

	public boolean eventMouseClick(int x, int y) {
		Component found = getCompAt(x,y);
		focus = found;
		if (found == null) { return false;}
		
		found.eventMouseClick(x-found.x, y-found.y);
		return true;
	}
	public boolean eventMouseMove(int x, int y) {
		Component found = getCompAt(x,y);
		if (found == null) { return false;}
		
		found.eventMouseMove(x-found.x, y-found.y);
		return true;
	}
	public boolean eventMouseDrag(int x, int y) {
		Component found = getCompAt(x,y);
		if (found == null) { return false;}
		
		found.eventMouseDrag(x-found.x, y-found.y);
		return true;
	}
	public boolean eventKeyCode(int code) {
		if (focus == null) return false;
		return focus.eventKeyCode(code);
	}
	public boolean eventKeyChar(char chr) {
		if (focus == null) return false;
		return focus.eventKeyChar(chr);
	}


}
















