package view.gui;

import java.awt.Color;

import view.GSnip;
import view.GraphicsEngine;
import model.Inventory;
import model.InventorySlot;
import model.LibIcons;

// spr == slots per row. usually 8

public class DisplayInventory extends Component {
	private final Inventory inv;
	private final int spr;
	
	public DisplayInventory(Inventory inv, int spr) {
		super();
		if (inv == null) throw new IllegalArgumentException("(Inventory)inv must not be null.");
		this.inv = inv;
		this.spr = spr; if (spr<1)spr=1;
	}
	
	@Override
	public GSnip redraw() {
		if (xs<=0)xs=1; if(ys<=0)ys=1;
		GSnip gs = new GSnip(xs,ys);
		int row = 0;
		
		final Color inner = new Color( 50, 50,100, 70);
		final Color outer = new Color(200,250,250,200);
		Color wutnow;
		
		for (int i=0; i<inv.getSlotCount(); i++) {
			if (i!=0 && i%spr==0) row++;
			
			for (int x=0; x<LibIcons.iconsize+2; x++) { // background and border
				for (int y=0; y<LibIcons.iconsize+2; y++) {
					if (x==0 || x%(LibIcons.iconsize+1)==0 || y==0 || y%(LibIcons.iconsize+1)==0) wutnow = outer; else wutnow = inner;
					gs.setraw((i%spr)*(LibIcons.iconsize+1+1+2)+x, row*(LibIcons.iconsize+1+1+2)+y, wutnow);
				}
			}
			
			InventorySlot s = inv.get(i);
			if (s == null) continue;
			GSnip icon = s.getIcon();
			if (icon == null) continue;
			icon.drawonto(gs, (i%spr)*(LibIcons.iconsize+4)+1, row*(LibIcons.iconsize+4)+1, LibIcons.iconsize, LibIcons.iconsize);
			
			GraphicsEngine.gstext((i%spr)*(LibIcons.iconsize+1+1+2)+3, row*(LibIcons.iconsize+1+1+2)+3, ""+s.getQuantity(), Color.green, 1, gs);
		}
		
		
		return gs;
	}
	
	
}
