package view.gui;

import java.awt.Color;
import java.awt.event.KeyEvent;

import view.GSnip;
import view.GraphicsEngine;

/**Single line! @see TextBox for fixWord*/
public class EditBox extends Component {
	protected String text;
	
	public EditBox() {
		text = "hai";
		initSize(80, 13);
	}
	
	@Override
	public GSnip redraw() {
		if (xs<=0) xs=1; if (ys<=0)ys=1;
		GSnip gs = new GSnip(xs, ys);
		
		Color fill = new Color(50, 70, 50, 100);
		if (myparent != null && myparent.getFocus() == this) fill = new Color(30, 70, 30, 170);
		
		for (int x=0; x<xs; x++) {
			for (int y=0; y<ys; y++) {
				gs.set(x,y, new Color(50, 90, 50, (int)(Math.random()*100+150)));
			}
		}
		for (int x=1; x<xs-1; x++) {
			for (int y=1; y<ys-1; y++) {
				gs.setraw(x,y, fill);
			}
		}
		
		int len = GraphicsEngine.gstext(2, 3, text, new Color(40, 255, 40, 255), 1, gs);
		
		if (myparent != null && myparent.getFocus() == this) {
			GraphicsEngine.gsdrawChar(2+len, 3, (char)130, new Color(20, 150, 40, 200), 1, gs);
		}
		
		return gs;
	}
	
	public String getText() { return text; }
	public void setText(String text) { this.text = text; }
	
	
	public boolean eventKeyChar(char chr) {
		if (chr == KeyEvent.VK_BACK_SPACE) {
			int len = text.length();
			if (len <= 0) return true;
			text = text.substring(0, len-1);
			return true;
		}
		text+=chr;
		return true;
	}
	
}




