package view.gui;

import model.Model;

public class MainMenu extends Window {

	Model model;

	Button millis;
	Button addpaint;
	Label millisdisplay;
	EditBox randomtext;
	CheckBox pause;
	HealthBar progress;
	Button savegame;
	EditBox savename;

	public void initsModel(Model m) {
		this.model = m;
	}

	public MainMenu() {
		super();
		setCaption("" + (char) 128 + " Mainmenu");

		resize(200, 150);

		// label to display miliseconds (-> )
		the.add(millisdisplay = new Label());
		millisdisplay.initParent(the);
		millisdisplay.initW(this);
		millisdisplay.initPosition(10, 30);
		millisdisplay.setText("System.currentTimeMillis();");

		// miliseconds trigger
		the.add(millis = new Button() {
			protected void oClick() {
				millisdisplay.setText("" + System.currentTimeMillis());
			}
		});
		millis.initParent(the);
		millis.initW(this);
		millis.initPosition(10, 8);
		millis.setText("millis");

		the.add(addpaint = new Button() {
			protected void oClick() {
				if (mywm != null) {
					FixPaint fp = new FixPaint();

					fp.initWM(mywm);
					fp.resize(100, 100);
					fp.move(10, 10);
					mywm.add(fp);
				}
			}
		});
		addpaint.initParent(the);
		addpaint.initW(this);
		addpaint.initPosition(95, 8);
		addpaint.setText("fixPaint");

		/*
		 * the.add(randomtext = new EditBox()); randomtext.initParent(the);
		 * randomtext.initW(this); randomtext.initPosition(14, 43);
		 * randomtext.initSize(the.xs-15-15, randomtext.ys);
		 */

		the.add(pause = new CheckBox() {
			protected void oStateChange() {
				if (model == null) {
					return;
				}
				model.pause(state);
			}
		});
		pause.initParent(the);
		pause.initW(this);
		pause.initPosition(9, 60);
		pause.initSize(pause.setText("Pause updating?"), pause.ys);

		the.add(progress = new HealthBar());
		progress.initW(this);
		progress.initParent(the);
		progress.initSize(100, progress.ys);
		progress.setProgress(0.7f);
		progress.initPosition(14, 70);

		the.add(savegame = new Button() {
			protected void oClick() {
				text = "Saving...";
				if (model == null) {
					text = "Save [ERR]";
					return;
				}
				model.save(savename.getText());
				text = "Save";
			}
		});
		savegame.initW(this);
		savegame.initParent(the);
		savegame.initPosition(10, 100);
		savegame.setText("Save");

		the.add(savename = new EditBox());
		savename.initW(this);
		savename.initParent(the);
		savename.initSize(xs - 10 - 10, savename.ys);
		savename.initPosition(10, 83);
		savename.setText("My save 1");

	}
}
