package view.gui;

import java.awt.Color;

import view.*;
import view.gui.WindowManager.WindowState;

public class Window implements WindowManager.KeyL, WindowManager.MouseL, WindowManager.MouseMotionL {
	// const
	public static final int frameleft   = 1;
	public static final int frameright  = 1;
	public static final int framebottom = 1;
	public static final int frametop    = 11;
	
	// type
	// ---
	
	// var
	int x,y, xs,ys; // coords of window, and of WINDOw size. not of the canvas size(see (var)"the")
	String caption;
	Container the; // sub: the main Component handling the canvas (which should behave as container!)
	WindowManager mywm; // parent: my window manager.
	WindowManager.WindowState state;
	
	// init
	public void initWM(WindowManager wm) { this.mywm = wm; }
	public Window() {
		this.state = WindowManager.WindowState.Normal;
		
		caption = "<untitled window>";
		
		x  =  10; y  =  10;
		xs = 100; ys = 100;
		
		the = new Container();
		the.initW(this);
		the.move(frameleft, frametop);
		the.resize(xs-frameleft-frameright, ys-frametop-framebottom);
		
		/*
		initThe(new Container());
		the.initParent(null);
		the.initPosition(frameleft, frametop);
		the.initW(this);
		the.initSize(getUsableCanvasSizeX(), getUsableCanvasSizeY());
		
		initWM(null);
		initSize(100, 100);
		initPosition(0, 0);
		initCaption("(untitled window)");
		initState(WindowState.Normal);
		*/
		
	}
	
	// get
	public int getUsableCanvasSizeX() { return xs-frameleft-frameright; }
	public int getUsableCanvasSizeY() { return ys-frametop-framebottom; }
	public int getX() { return x; }
	public int getY() { return y; }
	public int getWindowSizeX() { return xs; }
	public int getWindowSizeY() { return ys; }
	public Container getThe() { return the; }
	
	// set
	public void setCaption(String caption) { this.caption = caption; }
	
	//? core paint parts
	// ---
	/**Render "the" here. or customize*/
	protected void rReal(GraphicsEngine ge) {
		GSnip gs = the.redraw();
		gs.render(ge, x+the.x, y+the.y, getUsableCanvasSizeX(), getUsableCanvasSizeY());
	}
	
	// core
	public void render(GraphicsEngine ge) {
		float light = 0.77f;
		if (mywm != null && mywm.getFocus() == this) light = 0.95f;
		
		if (state == WindowState.Hold) {
			
			for (int x=this.x; x<this.x+xs; x++) {
				for (int y=this.y; y<this.y+frametop; y++) {
					ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light));
				}
			}
			if (caption != null) {
				GSnip gstitle = new GSnip(xs, frametop);
				GraphicsEngine.gstext(3, 2, caption, Color.cyan.darker(), 1, gstitle);
				
				gstitle.render(ge, this.x, this.y, this.xs+frameleft+frameright+10, frametop);
				
				/*
				for (int x=0; x<gstitle.xlen(); x++) {
					for (int y=0; y<gstitle.ylen(); y++) {
						if ((buf = gstitle.get(x, y)) == null) continue;
						ge.set(this.x+frameleft+x+3, this.y+2+y, gstitle.get(x, y));
					}
				}*/
			}
			// <restore button />
			for (int x=this.x+this.xs-frametop+frameleft; x<this.x+this.xs-1; x++) {
				for (int y=this.y+1; y<this.y+frametop-1; y++) {
					ge.seta(x, y, new Color(120,200,120, 200));
				}
			}
			
			return;
		} // END IF STATE == HOLD
		
		// <FRAME>
		// <titlebar background />
		for (int x=this.x; x<this.x+xs; x++) {
			for (int y=this.y; y<this.y+frametop; y++) {
				if (mywm != null && mywm.getFocus() == this) { ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light)); continue; }
				ge.set(x,y, GraphicsEngine.blendLight(ge.get(x, y), light));
			}
		}
		// left border ( only 1px (dispiting frameleft value))
		for (int y=this.y+frametop; y<this.y+this.ys; y++) {
			ge.set(this.x, y, GraphicsEngine.blendLight(ge.get(x, y), light));
		}
		// right border
		for (int y=this.y+frametop; y<this.y+this.ys; y++) {
			ge.set(this.x+this.xs-frameleft, y, GraphicsEngine.blendLight(ge.get(x+xs, y), light));
		}
		// bottom border
		for (int x=this.x+1; x<this.x+this.xs-1; x++) {
			ge.set(x, this.y+this.ys-framebottom, GraphicsEngine.blendLight(ge.get(x, y+ys), light));
		}
		// <close button />
		for (int x=this.x+this.xs-frametop+frameleft; x<this.x+this.xs-1; x++) {
			for (int y=this.y+1; y<this.y+frametop-1; y++) {
				ge.seta(x, y, new Color(200,150,150, 200));
			}
		}
		
		// <caption />
		if (caption != null) {
			GSnip gstitle = new GSnip(xs, frametop);
			GraphicsEngine.gstext(3, 2, caption, Color.cyan.darker(), 1, gstitle);
			
			gstitle.render(ge, this.x, this.y, this.xs+frameleft+frameright+10, frametop);
			
			/*
			for (int x=0; x<gstitle.xlen(); x++) {
				for (int y=0; y<gstitle.ylen(); y++) {
					if ((buf = gstitle.get(x, y)) == null) continue;
					ge.set(this.x+frameleft+x+3, this.y+2+y, gstitle.get(x, y));
				}
			}*/
		}
		// </FRAME>

		// canvas "the"
		rReal(ge);
		/*
		for (int x=0; x<gs.xlen(); x++) {
			for (int y=0; y<gs.ylen(); y++) {
				//if (y%wr == 0)
				ge.set(this.x+frameleft+x, this.y+frametop+y,
								GraphicsEngine.blend(ge.get(x+this.x+frameleft, y+this.y+frametop), gs.get(x,y)));
			}
		}
		*/
	}
	
	public void poke() {
		if (the != null) the.poke();
	}
	
	int dragx,dragy;
	public boolean startdrag(int x, int y) {
		
		// if (x<w.x || y<w.y || x>=w.x+w.xs || y>=w.y+w.ys) continue;
		if (x<0 || y<0 || x>=this.xs-frameleft-frametop-1 || y>=frametop) return false;
		
		dragx=x;
		dragy=y;
		
		return true;
	}
	public boolean drag(int x, int y) {
		move(this.x-dragx+x, this.y-dragy+y);
		return true;
	}
	public void stopdrag(int x, int y) {
		//move(x,y);
		if (this.x < 0) this.x=0;
		if (this.y < 0) this.y=0;
		if (this.x >= GraphicsEngine.WIDTH-10) this.x = GraphicsEngine.WIDTH-10;
		if (this.y >= GraphicsEngine.HEIGHT-5) this.y = GraphicsEngine.HEIGHT-5;
	}
	
	// ===
	public void resize(int xs, int ys) {
		this.xs=xs;
		this.ys=ys;
		the.resize(xs-frameleft-frameright, ys-frametop-framebottom);
	}
	public void move(int x, int y) { this.x=x; this.y=y; }
	
	public void close() {
		this.state = WindowState.Hold;
		if (mywm != null) mywm.holdAdd(this);
	}
	public void show() { // restore from tray/'hold'
		this.state = WindowState.Normal;
		if (mywm != null) mywm.holdPop(this);
	}
	
	// event
	// TODO
	public boolean eventMouseMove(int x, int y) {
		if (mywm == null) return false;
		if (mywm.isdragging()) return false;
		the.eventMouseMove(x-the.x, y-the.y);
		return true;
	}
	public boolean eventMouseDrag(int x, int y) {
		if (mywm == null) return false;
		if (mywm.isdragging()) return false;
		the.eventMouseDrag(x-the.x, y-the.y);
		return true;
	}
	public boolean eventMouseClick(int x, int y) {
		if (x>=this.xs-frametop+frameleft && y>=1 && x<this.xs-1 && y<frametop-1) {
			if (state == WindowState.Normal) close(); else show(); // toggle
			return true;
		}
		//if (mywm != null) mywm.bringTop(this);
		the.eventMouseClick(x-the.x, y-the.y);
		return true;
	}
	public boolean eventKeyCode(int code) { 
		if (state == WindowState.Hold) return false;
		the.eventKeyCode(code);
		return true;
	}
	public boolean eventKeyChar(char chr) {
		if (state == WindowState.Hold) return false;
		the.eventKeyChar(chr);
		return true;
	}
	
}
















