package gol;

import java.awt.event.KeyEvent;

import view.*;
import view.gui.*;
import model.*;
import mutil.MUtil;
import mutil.Vector2;

public class GoL implements View.MouseL, View.MouseMotionL, View.KeyL, View.FrameUpdateL {
	View view;
	Model model;

	MainMenu mainmenu;
	FixPaint paint;
	// StatsWindow stats;
	WindowInventory playerinv;
	
	int player_move_vert, player_move_horiz;

	public GoL() {
		
		player_move_vert = player_move_horiz = 0;
		
		model = new Model();
		view = new View(model);
		view.addMouseMotionL(this);
		view.addFrameUpdateL(this);
		view.addKeyL(this);
		view.addMouseL(this);

		mainmenu = new MainMenu();
		model.getWM().add(mainmenu);
		mainmenu.initWM(model.getWM());
		mainmenu.move(20, 20);
		mainmenu.initsModel(model);

		model.getWM().add(playerinv = new WindowInventory(model.getPlayer().getInv(), 8));
		playerinv.initWM(model.getWM());
		playerinv.setCaption("Player's inventory!");

		view.start();
	}

	public static void main(String[] args) {

		// System.out.println("[main] " + new
		// Bullet(Bullet.Type.Creeper).getLongName());
		// System.out.println("[main[ " + new
		// Bullet(Bullet.Type.Creeper).getLongType());

		GoL gol = new GoL();
	}

	@Override
	public void updateFrame(float delta) {

		model.getPlayer().push(Math.toRadians(90), player_move_vert); // vertical
		model.getPlayer().push(Math.toRadians(0), player_move_horiz); // horizontal
		
		model.getWorld().tick();

		/*
		 * 110629: commented out: minecraftification for (int x=0;
		 * x<model.getWidth(); x++) { for (int y=0; y<model.getHeight(); y++) {
		 * Pixie pix = model.get(x,y); if (pix == null) { continue; }
		 * 
		 * pix.update(model, delta);
		 * 
		 * /* Player p = model.getPlayer(); if (p == null)
		 * model.termPost("CORE[GoL.updateFrame]: mode.getPlayer() returned NULL!"
		 * );* / } } List<Pixie> enten = model.entenGet(); for (int i = 0; i <
		 * enten.size(); i++) { Pixie pix = enten.get(i); if (pix == null)
		 * continue; pix.update(model, delta); }
		 * 
		 * model.getPlayer().update(model, delta);
		 */
	}

	@Override
	public boolean mouseClicked(int x, int y) {
		if (model.useForms() && model.getWM().mouseClicked(x, y)) {
			return true;
		}

		// ===

		for (int i = 0; i < 4; i++) {/*
									 * 110629: commented out: minecraftification
									 * &&& simply no shooting Thing projectile =
									 * new Bullet(Bullet.Type.STD); // use 300f
									 * as speed model.getPlayer().shoot(x, y,
									 * 200f,
									 * (float)(Math.atan2(y-model.getPlayer().y,
									 * x-model.getPlayer().x)), projectile);
									 * model.entenAdd(projectile);
									 */
		}
		return true;
	}
	public boolean mouseMoved(int x, int y) {
		if (model.useForms() && model.getWM().mouseMoved(x, y)) {
			return true;
		}

		// ===

		return false;
	}
	public boolean mouseDragged(int x, int y) {
		if (model.useForms() && model.getWM().mouseDragged(x, y)) {
			return true;
		}

		// ===

		return false;

		/*
		 * model.set((float)x , (float)y , new Dirt()); model.set((float)x+1,
		 * (float)y , new Dirt()); model.set((float)x-1, (float)y , new Dirt());
		 * model.set((float)x , (float)y+1, new Dirt()); model.set((float)x ,
		 * (float)y-1, new Dirt());
		 */
		// model.set(x-1, y-1, new Pixie(-1));
		// model.set(x-1, y+1, new Pixie(-1));
		// model.set(x+1, y-1, new Pixie(-1));
		// model.set(x+1, y+1, new Pixie(-1));
		// model.termPost("You set a pixel at x:"+x+"|y:"+y);
		// return true; // we consumed it.!
		// return false;
	}
	public boolean keyTyped(char letter) {
		if (model.useForms() && model.getWM().keyTyped(letter)) {
			return true;
		}

		// ===

		return false;
	}
	public boolean keyPressed(int code)
	{
		if (code == KeyEvent.VK_ESCAPE) { model.useForms(!model.useForms()); return true; }
		if (model.useForms() && model.getWM().keyPressed(code)) return true;

		final double playerpush = 0.25;
		
		
		switch (code) {
		case KeyEvent.VK_UP:    if(player_move_vert  == 0) player_move_vert =-1; break;
		case KeyEvent.VK_DOWN:  if(player_move_vert  == 0) player_move_vert = 1; break;
		case KeyEvent.VK_LEFT:	if(player_move_horiz == 0) player_move_horiz=-1; break;
		case KeyEvent.VK_RIGHT: if(player_move_horiz == 0) player_move_horiz= 1; break;
		
		case KeyEvent.VK_Q: model.createMaze(); return true; // TODO on map load ( or button)
		}
		
		return false;
	}
	public boolean mouseDown(int x, int y) {
		if (model.useForms() && model.getWM().mouseDown(x, y)) {
			return true;
		}
		return false;
	}
	public boolean mouseUp(int x, int y) {
		if (model.useForms() && model.getWM().mouseUp(x, y)) {
			return true;
		}
		return false;
	}

	@Override
	public boolean keyReleased(int code) {
		switch (code) {
		case KeyEvent.VK_UP:    player_move_vert =0; break;
		case KeyEvent.VK_DOWN:  player_move_vert =0; break;
		case KeyEvent.VK_LEFT:	player_move_horiz=0; break;
		case KeyEvent.VK_RIGHT: player_move_horiz=0; break;
		}
		
		return false;
	}
}







