package model;

import java.awt.Color;

import view.GSnip;

public enum Block {
 // NAME........... [DATA | SOLID | ICON| INSL| INSR| INST| INSB|LIGHT]
	air				(    0, false , null,    0,    0,    0,    0,    0),
	stone			(    0, true  , null,    0,    0,    0,    0,    0),
	dirt			(    0, true  , null,    0,    0,    0,    0,    0),
	torch			(    0, false , null, 0.45, 0.45, 0.45, 0.45, 0.30), // TODO wire up torch
	b4,
	b5,
	b6,
	b7,
	b8,
	b9,
	b10,
	b11,
	b12,
	b13,
	b14,
	b15,
	b16,
	b17,
	b18,
	b19,
	b20,
	b21,
	b22,
	b23,
	b24,
	b25,
	b26,
	b27,
	b28,
	b29,
	b30,
	b31;
  //block 32,
  //block 33,
  //...
  //block 4294967295,
  //block 4294967296;
	
	private int data; // at least 32bits of your own memory!
	public final boolean solid; // can player walk through?
	public final GSnip icon; // icon to appear in inventory
	public final double insl, insr, inst, insb; // insets of the box (ie. set all to about 0.45d to get a centred stick(gonna use for torch) ) TODO make these affect anything actually...
	public final double light; // how much light is being emmited. (0: none. 1:double sunlight?)

	Block(int data, boolean solid, GSnip icon, double insl, double insr, double inst, double insb, double light) {
		this.solid = solid;
		this.icon = icon;
		this.data = data;
		this.insl = insl;
		this.insr = insr;
		this.inst = inst;
		this.insb = insb;
		this.light = light;
	}
	Block() {
		solid = true;
		icon = Lib.icons.byBlock(this);
		data = 0;
		insl = 0;
		insr = 0;
		inst = 0;
		insb = 0;
		light = 0D;
	}
	Block(int data) {
		this();
		this.data = data;
	}
	public @Deprecated double insLL(double x) { return x+insl; }
	public @Deprecated double insTT(double y) { return y+inst; }
	public @Deprecated double insRR(double x) { return x+1-insr; }
	public @Deprecated double insBB(double y) { return y+1-insb; }
	public double insWidth () { return 1-insl-insr; }
	public double insHeight() { return 1-inst-insb; }

	public @Deprecated boolean isSolid() { return solid; }

	public int getData() { return data; }
	public void setData(int data) { this.data = data; }

	public String toString() {
		String ret;

		switch (this) {
		case stone: 	ret = "stone"; break;
		case dirt: 		ret="dirt"; break;

		default: 		ret="air";
		}

		if (data == 0) return ret;
		else return ret + ":" + data;
	}
	public String encode() { // TODO "4E 55 4D 42   44 41 54 41" (without
								// spaces)
		String type = Integer.toHexString(this.ordinal());
		String data = Integer.toHexString(getData());

		int tlen = type.length();
		int dlen = data.length();

		for (int i = 0; i < (8 - tlen); i++) {
			type = "0" + type;
		}
		for (int i = 0; i < (8 - dlen); i++) {
			data = "0" + data;
		}

		return type + data;
	}
	public static Block decode(String wut) {
		Block b = Block.values()[Integer.parseInt(wut.substring(0, 8), 16)];

		b.setData(Integer.parseInt(wut.substring(9, 16), 16));
		return b;
	}

}
