package model;

import mutil.MUtil;
import mutil.Rect;

/*
 * act_whatever(...):
 * return codes:
 * 0: no action
 * negative: errors.
 * positive: anything you like.
 */

public class Entity {
	protected double x, y; // finer calculations only with entities
	protected final long eid; // entitiy global ID
	protected Chunk chunk; // in which chunk am i ?
	protected final World world;
	
	public Entity(World in, double x, double y) {
		if (in == null) { throw new IllegalArgumentException("(World)in must not be null."); }
		this.x = x;
		this.y = y;
		this.chunk = in.ensureChunkAt((int) x, (int) y);
		this.chunk.entityadd(this);
		this.eid = in.entityallocate(this);
		this.world = in;
	}
	protected Entity(World raw_world, long raw_eid) {this.eid = raw_eid; this.world = raw_world; }

	public boolean isOpaque() {
		return false;
	}

	public double insL() { return 0; }
	public double insR() { return 0; }
	public double insT() { return 0; }
	public double insB() { return 0; }
	public double insLL() { return this.x+insL(); }
	public double insTT() { return this.y+insT(); }
	public double insRR() { return this.x+1-insR(); }
	public double insBB() { return this.y+1-insB(); }
	public double insWidth() { return 1-insL()-insR(); }
	public double insHeight() { return 1-insT()-insB(); }
	
	public int act_Primary(double x, double y) { return 0; }
	public int act_Secondary(double x, double y) { return 0; }

	public static final Entity decode(String str) {
		return null; // TODO
	}
	public String encode() {
		String ret = "";
		ret += eid + ",";
		ret += x + "," + y;
		return ret;
	}

	public double getX() { return x; }
	public double getY() { return y; }
	
	public void update(double delta) { }
	public void destroyme() {
		if (world != null)       world     .entitykill(eid);
		else               chunk.getWorld().entitykill(eid);
	}
	public World getWorld() { return world; }
	public Chunk getChunk() { return chunk; }
	public long getEID() { return eid; }
	public void move(double x, double y) {
		Chunk nc = chunk.getWorld().ensureChunkAt((int) x, (int) y);
		this.x = x;
		this.y = y;
		
		if (nc == chunk) { return; }
		chunk.entityrem(this);
		nc.entityadd(this);
		chunk = nc;
	}
}
