package model;

import java.awt.Color;

public class EntityAnimation extends Entity {
	private double progress;
	private final Color color;
	private final double insl, insr, inst, insb;
	
	public EntityAnimation(World in, double x, double y             ) { this(in, x, y, Color.white); }
	public EntityAnimation(World in, double x, double y, Color color) { this(in, x, y, color, 0,0,0,0); }
	public EntityAnimation(World in, double x, double y, Color color, double width, double height) { this(in, x, y, color, 0, 0, width, height); }
	public EntityAnimation(World in, double x, double y, Color color, double insl, double insr, double inst, double insb) {
		super(in,x,y);
		this.color = color;
		this.insl = insl;
		this.insr = insr;
		this.inst = inst;
		this.insb = insb;
	}
	
	public double insL() { return insl; }
	public double insR() { return insr; }
	public double insT() { return inst; }
	public double insB() { return insb; }
	
	public double getProgress() { return progress; }
	
	public Color getColor() { return color; }
	
	public double getDurationSeconds() { return 1d; }
	
	@Override
	public void update(double delta) {
		progress += delta * getDurationSeconds();
		if (progress >= 1d) destroyme();
	}
	
}
