package model;

import java.util.Queue;

public @SuppressWarnings("rawtypes")
class Inventory {
	InventorySlot[] slots;

	public Inventory(int amount) {
		slots = new InventorySlot[amount];

	}

	public InventorySlot get(int slot) {
		if (slot < 0 || slot >= slots.length) {
			return null;
		}
		return slots[slot];
	}

	public int getSlotCount() {
		return slots.length;
	}

	public int push(Object wut) {
		for (int i = 0; i < slots.length; i++) {
			InventorySlot s = slots[i];

			if (s == null) {
				s = (slots[i] = new InventorySlot(wut));
				return i;
			}
			if (s.isCompatible(wut)) {
				if (s.push(wut)) {
					return i;
				}
			}
			if (s.isEmpty()) {
				s = (slots[i] = new InventorySlot(wut));
				return i;
			} // if (s.isEmtpy()) { slots[i] = null; i--; continue; }
		}
		return -1;
	}

	public int pushto(Object wut, int slot) {
		if (slot < 0 || slot >= slots.length) {
			return -1;
		}

		InventorySlot s = slots[slot];

		if (s == null) {
			slots[slot] = new InventorySlot(wut);
			return slot;
		}
		if (s.isCompatible(wut)) {
			if (s.push(wut)) {
				return slot;
			}
		}
		if (s.isEmpty()) {
			slots[slot] = new InventorySlot(wut);
			return slot;
		}

		return -1;
	}

	public Object popfrom(int slot) {
		if (slot < 0 || slot >= slots.length) {
			return null;
		}

		InventorySlot s = slots[slot];

		if (s == null) {
			return null;
		}
		return s.pop();
	}

	public Object peekfrom(int slot) {
		if (slot < 0 || slot >= slots.length) {
			return null;
		}

		InventorySlot s = slots[slot];

		if (s == null) {
			return null;
		}
		return s.peek();
	}
}
