package model;

import java.awt.Color;
import java.util.LinkedList;
import java.util.List;

import mutil.Undone;

/*
 * 
 * (double)1.0b == one block
 * (double)0.5b == a half block
 * Blocks can only be SMALLER than 1 block. (thus insets valid are: 0.0->1.0)
 * 
 * COORD MODIFIERS:
 * absolute / relative
 * normal / chunkish
 * 
 * a	absolute: from world's zero
 * r	relative: from current chunk's zero
 * 
 * -	normal: in block coords context
 * ch	chunkish: in chunk coords context
 * `-> (chunkish*cs) == normal
 * `-> (Math.floor(normal/cs) == chunkish)
 * 
 * INSETS:
 * 1.0d: unmodified
 * 0.4d: 
 * 
 */

public class World {
	private static final int cs = Chunk.cs;
	private static final int zoom = Model.zoom;
	
	List<Chunk> chunks; // all the chunks
	private Entity[] entities; // global entities storer
	private List<Entity> entitiesl; // their list.
	long lasttime;

	public World() {
		chunks = new LinkedList<Chunk>();
		entities = new Entity[65536];
		entitiesl = new LinkedList<Entity>();
		lasttime = System.currentTimeMillis();
		tick();
	}

	
	public static boolean intersects(double axa, double aya, double axb, double ayb,    double bxa, double bya, double bxb, double byb) {
		//                        1{ left1       top1        right1      bottom1   } 2{left2       top2        right2      bottom2  }
		
		
		
//		//* found on internet! yaaa!
//		short int Sprite_Collide(sprite_ptr object1, sprite_ptr object2) {
//		int left1, left2;
//		int right1, right2;
//		int top1, top2;
//		int bottom1, bottom2;
//		
//		left1 = object1->x;
//		left2 = object2->x;
//		right1 = object1->x + object1->width;
//		right2 = object2->x + object2->width;
//		top1 = object1->y;
//		top2 = object2->y;
//		bottom1 = object1->y + object1->height;
//		bottom2 = object2->y + object2->height;
//		
//		if (bottom1 < top2) return(0);
//		if (top1 > bottom2) return(0);
//		
//		if (right1 < left2) return(0);
//		if (left1 > right2) return(0);
//		
//		return(1);
		 
		
//		if (ayb < bya) return false;
//		if (aya > byb) return false;
//		if (axb < bya) return false;
//		if (axa > bxb) return false;
//		return true;
		
		
		if (    Math.abs(axa + axb - bxa - bxb) < (axb - axa + bxb - bxa))
			if (Math.abs(aya + ayb - bya - byb) < (ayb - aya + byb - bya))
				return true;
		return false;
		 
	}

	public static boolean intersects(Entity a, Entity b) {
		if (a==null || b==null || a==b) return false;
		double axa=a.x+a.insL(),aya=a.y+a.insT(),axb=a.x+1-a.insR(),ayb=a.y+1-a.insB();
		double bxa=b.x+b.insL(),bya=b.y+b.insT(),bxb=b.x+1-b.insR(),byb=b.y+1-a.insB();
		
		if (    Math.abs(axa + axb - bxa - bxb) < (axb - axa + bxb - bxa))
			if (Math.abs(aya + ayb - bya - byb) < (ayb - aya + byb - bya))
				return true;
		return false;
		
		/*
		public boolean Intersects(Rect other) {
		  if ( Math.abs(ax + bx - other.ax - other.bx) < (bx - ax + other.bx - other.ax) )
		    if ( Math.abs(ay + by - other.ay - other.by) < (by - ay + other.by - other.ay) )
		      return true;
		  return false;
		} 
		 */
	}
	
	public List<Entity> getEntities() { return entitiesl; }
	public List<Chunk> getChunks() { return chunks; }

	public @Undone Entity raytraceMK(double fromx, double fromy, double tox, double toy) {
		// x1 y1 x2 y2
		// System.out.print("raytrace");

		double xx = fromx;
		double yy = fromy;

		for (int z = 0; z < chunks.size(); z++) {

			Chunk c = chunks.get(z);
			for (int i = 0; i < c.cs; ++i)
				for (int j = 0; j < c.cs; ++j) {
					Block b = c.data[i][j];

					if (tox>=i*8 && toy>=j*8 && tox<=(i+1)*8 && toy<=(j+1)*8) {
						if (b != null && b != Block.air && b.solid) return new BlockX(b, fromx, fromy);
					}
				}

		}

		for (int i = 0; i < entitiesl.size(); i++) {
			Entity e = entitiesl.get(i);
			if (!e.isOpaque())
				continue;
			if (!intersects(e.x + e.insL(), e.y + e.insT(), e.x + 1 - e.insR(), e.y + 1 - e.insB(), fromx, fromy, tox, toy))
				continue;
			return e; // TODO returns all e's in the delta square! not in the
						// ray of movement!
		}

		return null;
	}
	
	// please remember, this adds the insets of the whatfrom to tox/toy, so be a bit dumber using this.
	public Entity raytrace(Entity whatfrom, double tox, double toy) { return raytrace(whatfrom.insLL(), whatfrom.insTT(), whatfrom.insWidth(), whatfrom.insHeight(), tox+whatfrom.insL(), toy+whatfrom.insT()); }
	public Entity raytrace(double fromx, double fromy, double fromboxwidth, double fromboxheight, double tox, double toy) {
		System.out.printf("DEBUG [model.World raytrace] %f %f %f %f %f %f \n", fromx, fromy, fromboxwidth, fromboxheight, tox, toy);
		
		int bx=(int)tox;
		int by=(int)toy;
		Block b = get(bx, by);
		
		if (intersects( fromx, fromy, fromx+fromboxwidth, fromy+fromboxheight,       bx, by, bx+1, by+1             )) {
			return new BlockX(b, bx, by);
		}
		
		return null;
	}
	
	/*public Entity raytrace(double fromx, double fromy, double fromboxwidth, double fromboxheight, double tox, double toy) {
		double len = Math.sqrt(  Math.pow(tox-fromx,2) + Math.pow(toy-fromy, 2)  );
		if (len == 0) return null;
		
		double addx = (tox-fromx)/len/Model.zoom;
		double addy = (toy-fromy)/len/Model.zoom;
		//System.out.print(addx);
		while (((int)fromx != (int)tox || (int)fromy != (int)toy) && ( addx<0 ? fromx>=tox : fromx<=tox) && ( addy<0 ? fromy>=toy : fromy<=toy))
		{
			fromx += addx;
			fromy += addy;

			int ifromx = (int)fromx;
			int ifromy = (int)fromy;
			
			Block b = get(ifromx, ifromy);
			
			//Color rc = new Color((float)Math.random(), (float)Math.random(), (float)Math.random()); // TODO remove debug
			new EntityAnimation(this, fromx, fromy, Color.blue);                                      // ^

			if (!b.solid) continue;
			
			if (intersects(fromx,fromy,fromx+fromboxwidth,fromy+fromboxheight, ifromx+b.insl, ifromy+b.inst, ifromx+1-b.insr, ifromy+1-b.insb )) {
				return new BlockX(b, fromx, fromy); // FIXME return
			}

		}

		/* Temporary commented
		for (int i=0; i<entitiesl.size(); i++) {
			Entity e = entitiesl.get(i);
			if (!e.isOpaque()) continue;
			if (!intersects(e.x+e.insL(),e.y+e.insT(),e.x+1-e.insR(),e.y+1-e.insB(), fromx,fromy,tox,toy )) continue;
			return e; // TODO returns all e's in the delta square! not in the ray of movement!
		} * /
		
		return null;
	}*/
	
	/** ret[1]: wall. ret[0]: last okay position */
	public Entity raytrace(double fromx, double fromy, double tox, double toy) {
		double len = Math.sqrt(  Math.pow(tox-fromx,2) + Math.pow(toy-fromy, 2)  );
		if (len == 0) return null;
		
		double addx = (tox-fromx)/len;
		double addy = (toy-fromy)/len;
		while ((fromx != tox || fromy != toy) && ( addx<0 ? fromx>=tox : fromx<=tox) && ( addy<0 ? fromy>=toy : fromy<=toy))
		{
			fromx += addx;
			fromy += addy;

			Block b = get((int)fromx, (int)fromy);
			if (b!=null && b.solid) return new BlockX(b, fromx, fromy);

		}

		for (int i=0; i<entitiesl.size(); i++) {
			Entity e = entitiesl.get(i);
			if (!e.isOpaque()) continue;
			if (!intersects(e.x+e.insL(),e.y+e.insT(),e.x+1-e.insR(),e.y+1-e.insB(), fromx,fromy,tox,toy )) continue;
			return e; // TODO returns all e's in the delta square! not in the ray of movement!
		}
		
		return null;
		
		// float len = (float) Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 -
		// y1, 2));
		// if ( len == 0 ) {
		// //TODO: Make this function stop if this happens.
		// return null;
		// }
		//
		// double addx = (x2 - x1)/len;
		// double addy = (y2 - y1)/len;
		//
		// while (((int) x1 != (int) x2 || (int) y1 != (int) y2) && (addx < 0 ?
		// x1 >= x2 : x1 <= x2) && (addy < 0 ? y1 >= y2 : y1 <= y2)) {
		// x1 += addx;
		// y1 += addy;
		//
		// Block b = get((int)Math.round(x1), (int)Math.round(y1));
		// if (b == null || b == Block.air) continue;
		// //more emptiness conditions
		//
		// BlockX[] ret = new BlockX[2];
		//
		// BlockX prev = new BlockX(Block.air, x1-addx, y1-addy);
		// BlockX curr = new BlockX(null);
		// ret[1] = new BlockX(b); // the wall
		// if (prev != null) {
		// ret[0] = new BlockX(null); // TODO ask evan
		// } else {
		// ret[0] = new BlockX(Block.air, x1-addx, y1-addy); // yay
		// }
		// return ret;
		// }
		//
		// return null;

	}

	public long entityallocate(Entity ente) {
		synchronized (entitiesl) {
			for (int i = 0; i < entities.length; i++) {
				if (entities[i] == null) {
					entities[i] = ente;
					//System.out.printf("WORLD [Entity %d] Allocated EID for %s\n", i, ente);
					entitiesl.add(ente);
					return i;
				}
			}
			System.out.printf("WORLD [Entity -1] Failed to allocate EID for %s\n", ente);
		}
		return -1;
	}
	public void entitykill(long eid) {
		synchronized(entitiesl) {
			if (eid >= 0 && eid < entities.length) {
				Entity e = entities[(int) eid];

				if (e == null) { System.out.printf("WORLD [Entity %d] Failed to remove Entity by EID (Slot already null)\n", eid); return; }

				entities[(int) eid] = null;
				Chunk c;
				entitiesl.remove(e);

				(c = e.getChunk()).entityrem(eid);
				//System.out.printf("WORLD [Entity %d] Removed %s (from %s)\n", e.eid, e, c);
				return;
			}
			System.out.printf("WORLD [Entity %d] Failed to remove Entity by EID (Out of range)\n", eid);
		}
	}
	public void entitiesUpdate(double delta) {
		for (int i=0; i<entitiesl.size(); i++) {
			Entity e = entitiesl.get(i);
			if (e != null) {
				e.update(delta);
			}
		}
		
		
		
	}
	public void tick() {
		long nowtime = System.currentTimeMillis();

		entitiesUpdate(((double) nowtime - (double) lasttime) / 1000d);
		lasttime = nowtime;
	}

	public Block get(int x, int y) {
		Chunk c = getChunkAt(x, y);

		if (c != null) {
			return c.geta(x, y);
		}
		return Block.air;
	}
	public void set(int x, int y, Block datatype) {
		Chunk c = ensureChunkAt(x, y);

		c.seta(x, y, datatype);
	}
	public Chunk ensureChunkAt(int x, int y) {
		// for (Chunk c : chunks) if (x>=c.x*cs && y>=c.y*cs && x<(c.x+1)*cs &&
		// y<(c.y+1)*cs) return c;
		Chunk c = getChunkAt(x, y);

		if (c != null) return c;
		
		c = new Chunk(this, (int)(x / cs), (int)(y / cs));
		chunks.add(c);
		return c;
	}
	public Chunk getChunkAt(int x, int y) {
		for (int i=0; i<chunks.size(); i++) {
			Chunk c = chunks.get(i);
			if (x >= c.x * cs && y >= c.y * cs && x < (c.x + 1) * cs && y < (c.y + 1) * cs) {
				return c;
			}
		}
		return null;
	}
	public Chunk getChunk(int chx, int chy) {
		for (Chunk c : chunks) {
			if (chx == c.x && chy == c.y) {
				return c;
			}
		}
		return null;
	}
}






































