package trace2d;

import java.util.Vector;

public class TraceWorld {
	
	private Vector<TraceObject> traceObjects; // List of trace objects.
	public float blockSize; // How big are blocks relative to one position unit?
	
	/**
	 * @return Number of TraceObjects.
	 */
	public int numObjects() {
		return traceObjects.size();
	}
	
	public TraceObject get(int index) {
		return index >= 0 && index < numObjects() ? traceObjects.get(index) : null;
	}
	
	/**
	 * Removes an object from the traceObjects list.
	 * @param traceObject The object to remove.
	 * @return Removed ? true : false.
	 */
	public boolean remove(TraceObject traceObject) {
		return traceObjects.remove(traceObject);
	}
	
	/**
	 * Determines whether or not traceObjects contains the object
	 * @param traceObject The object to test.
	 * @return Has it ? true : false.
	 */
	public boolean hasObject(TraceObject traceObject) {
		return traceObjects.contains(traceObject);
	}
	
	/**
	 * Adds an object to the traceObjects list if it is not on the list already.
	 * @param traceObject The object to test.
	 */
	public void add(TraceObject traceObject) {
		if ( !hasObject(traceObject) ) {
			traceObjects.add(traceObject);
		}
	}
	
	/**
	 * Tests if a point in block coordinates is solid or not.
	 * Note: 1 Block coordinate = 1 blockSize of the position unit.
	 * @param x Block x.
	 * @param y Block y.
	 * @return Is solid? true : false.
	 */
	public boolean isSolid(int x, int y) {
		return false;
	}
	
	public TraceWorld() {
		traceObjects = new Vector<TraceObject>();
		blockSize = 1;
	}
}
