package trace2d;

public class trace {
	public static TraceWorld world;
	
	/**
	 * Change this however needed.
	 * @param txt
	 */
	public static void debugPrint(String txt) {
		System.out.println(txt);
	}
	
	// Potentially used in recursive functions...
	private static float minX = 0, minY = 0, maxX = 0, maxY = 0, nX = 0, nY = 0;
	private static boolean right = false, down = false;
	
	public static TraceData traceEntityLine(float fromX, float fromY, float toX, float toY, TraceObject toIgnore) {
		
		TraceData data = new TraceData();
		
		float len = (float)Math.sqrt(Math.pow(toX - fromX, 2) + Math.pow(toY - fromY, 2));
		
		if ( len == 0 ) {
			// Silent error.
			return data;
		}
		
		minX = Math.min(fromX, toX);
		minY = Math.min(fromY, toY);
		
		maxX = Math.max(fromX, toX);
		maxY = Math.max(fromY, toY);
		
		nX = (toX - fromX)/len;
		nY = (toY - fromY)/len;
		
		right = nX > 0;
		down = nY > 0;
		
		boolean dc = false;
		
		float d = 0;
		float px = 0, py = 0;
		
		float closest = -1;
		
		for ( int i = 0; i < world.numObjects(); i++ ) {
			TraceObject o = world.get(i);
			if ( o != toIgnore ) {
				if ( right ) {
					d = Math.abs(o.traceX - fromX);
					
					//p = a.plus(normal.multipliedBy(d/Math.abs(normal.x)));
					
					px = fromX + (nX * (d/Math.abs(nX)));
					py = fromY + (nY * (d/Math.abs(nX)));
					
					dc = 
						( py >= o.traceX && py <= o.traceX + o.traceHeight) &&
						( px == o.traceX );
					
					if ( dc ) {
						d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
						if ( closest == -1 || d < closest ) {
							closest = d;
							data.doesCollide = true;
							data.normalX = -1;
							data.normalY = 0;
							data.x = px;
							data.y = py;
						}
					}
				} else if ( !right ) {
					d = Math.abs((o.traceX + o.traceWidth) - fromX);
					
					px = fromX + (nX * (d/Math.abs(nX)));
					py = fromY + (nY * (d/Math.abs(nX)));
					
					dc = 
							( py >= o.traceX && py <= o.traceX + o.traceHeight) &&
							( px == o.traceX + o.traceWidth );
					
					if ( dc ) {
						d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
						if ( closest == -1 || d < closest ) {
							closest = d;
							data.doesCollide = true;
							data.normalX = 1;
							data.normalY = 0;
							data.x = px;
							data.y = py;
						}
					}
				}
			}
			
			if ( nY != 0 ) { 
				if ( down  ) {
					d = Math.abs(o.traceY - fromY);
					
					px = fromX + (nX * (d/Math.abs(nY)));
					py = fromY + (nY * (d/Math.abs(nY)));
					
					dc = 
						( px >= o.traceX && px <= o.traceX + o.traceWidth ) &&
						( py == o.traceY );
					
					if ( dc ) {
						d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
						if ( closest == -1 || d < closest ) {
							closest = d;
							data.doesCollide = true;
							data.normalX = 0;
							data.normalY = -1;
							data.x = px;
							data.y = py;
						}
					}
				} else if ( !down ) {
					d = Math.abs((o.traceY + o.traceHeight) - fromY);
					
					px = fromX + (nX * (d/Math.abs(nY)));
					py = fromY + (nY * (d/Math.abs(nY)));
					
					dc = 
							( px >= o.traceX && px <= o.traceX + o.traceWidth ) &&
							( py == o.traceY + o.traceHeight );
					
					if ( dc ) {
						d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
						if ( closest == -1 || d < closest ) {
							closest = d;
							data.doesCollide = true;
							data.normalX = 0;
							data.normalY = 1;
							data.x = px;
							data.y = py;
						}
					}
				}
			}
		}
		
		return data;
	}
	
	public static TraceData traceEntityLine(float fromX, float fromY, float toX, float toY) {
		return traceEntityLine(fromX, fromY, toX, toY, null);
	}
	
	/**
	 * Traces a line an tests if it collides with a block in the world.
	 * @param fromX Start x.
	 * @param fromY Start y.
	 * @param toX End x.
	 * @param toY End y.
	 * @return TraceData based on collision.
	 */
	public static TraceData traceLine(float fromX, float fromY, float toX, float toY) {
		
		TraceData data = new TraceData();
		
		if ( world == null ) {
			debugPrint("TraceWorld is null!");
			return data;
		}
		
		float len = (float)Math.sqrt(Math.pow(toX - fromX, 2) + Math.pow(toY - fromY, 2));
		
		if ( len == 0 ) {
			// Silent error.
			return data;
		}
		
		minX = Math.min(fromX, toX);
		minY = Math.min(fromY, toY);
		
		maxX = Math.max(fromX, toX);
		maxY = Math.max(fromY, toY);
		
		nX = (toX - fromX)/len;
		nY = (toY - fromY)/len;
		
		right = nX > 0;
		down = nY > 0;
		
		boolean dc = false;
		
		float d = 0;
		float px = 0, py = 0;
		
		float closest = -1;
		
		for ( int x = (int)(minX/world.blockSize); x <= (int)(maxX/world.blockSize); x++ ) {
			for ( int y = (int)(minY/world.blockSize); y <= (int)(maxY/world.blockSize); y++ ) {
				if ( world.isSolid(x, y)) {
					if ( nX != 0 ) {
						if ( right && !world.isSolid(x - 1, y) ) {
							d = Math.abs(((float)x)*world.blockSize - fromX);
							
							//p = a.plus(normal.multipliedBy(d/Math.abs(normal.x)));
							
							px = fromX + (nX * (d/Math.abs(nX)));
							py = fromY + (nY * (d/Math.abs(nX)));
							
							dc = 
								( py >= y*world.blockSize && py <= y*world.blockSize + world.blockSize ) &&
								( px == x*world.blockSize );
							
							if ( dc ) {
								d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
								if ( closest == -1 || d < closest ) {
									closest = d;
									data.doesCollide = true;
									data.normalX = -1;
									data.normalY = 0;
									data.x = px;
									data.y = py;
								}
							}
						} else if ( !right && !world.isSolid(x + 1, y) ) {
							d = Math.abs((((float)x)*world.blockSize + world.blockSize) - fromX);
							
							//p = a.plus(normal.multipliedBy(d/Math.abs(normal.x)));
							
							px = fromX + (nX * (d/Math.abs(nX)));
							py = fromY + (nY * (d/Math.abs(nX)));
							
							dc = 
								( py >= y*world.blockSize && py <= y*world.blockSize + world.blockSize ) &&
								( px == x*world.blockSize + world.blockSize );
							
							if ( dc ) {
								d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
								if ( closest == -1 || d < closest ) {
									closest = d;
									data.doesCollide = true;
									data.normalX = 1;
									data.normalY = 0;
									data.x = px;
									data.y = py;
								}
							}
						}
					}
					
					if ( nY != 0 ) { 
						if ( down && !world.isSolid(x, y - 1) ) {
							d = Math.abs(((float)y)*world.blockSize - fromY);
							
							px = fromX + (nX * (d/Math.abs(nY)));
							py = fromY + (nY * (d/Math.abs(nY)));
							
							dc = 
								( px >= x*world.blockSize && px <= x*world.blockSize + world.blockSize ) &&
								( py == y*world.blockSize );
							
							if ( dc ) {
								d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
								if ( closest == -1 || d < closest ) {
									closest = d;
									data.doesCollide = true;
									data.normalX = 0;
									data.normalY = -1;
									data.x = px;
									data.y = py;
								}
							}
						} else if ( !down && !world.isSolid(x, y + 1) ) {
							d = Math.abs((((float)y)*world.blockSize + world.blockSize) - fromY);
							
							px = fromX + (nX * (d/Math.abs(nY)));
							py = fromY + (nY * (d/Math.abs(nY)));
							
							dc = 
								( px >= x*world.blockSize && px <= x*world.blockSize + world.blockSize ) &&
								( py == y*world.blockSize + world.blockSize );
							
							if ( dc ) {
								d = (float)Math.sqrt(Math.pow(px - fromX, 2) + Math.pow(py - fromY, 2));
								if ( closest == -1 || d < closest ) {
									closest = d;
									data.doesCollide = true;
									data.normalX = 0;
									data.normalY = 1;
									data.x = px;
									data.y = py;
								}
							}
						}
					}
				}
			}
		}
		
		return data;
	}
}
