package view;

import java.awt.Color;

import model.Entity;
import model.EntityAnimation;
import model.Model;
import mutil.Coord;

public abstract class RenderAnimation {
	private static final int zoom = Model.zoom;
	private static Model model;
	public static void initModel(Model model) {
		RenderAnimation.model = model;
	}
	private static int offx() {
		if (model == null) {
			return 0;
		}
		return model.scrollX();
	}
	private static int offy() {
		if (model == null) {
			return 0;
		}
		return model.scrollY();
	}
	
	public static final void render(EntityAnimation wut, GraphicsEngine ge) {
		if (wut instanceof EntityAnimation) renderAnimation(wut,ge);
		// else if...
	}
	
	public static void renderAnimation(EntityAnimation wut, GraphicsEngine ge) {
		//simpleFill(ge, model.coordWorld2Screen(wut.getX(),wut.getY()), new Color(0.9f,0.9f,0.9f,(float)(1-wut.getProgress()) ));
		Color wutcl = wut.getColor();
		simpleRender(wut, ge, new Color(wutcl.getRed()/255f,wutcl.getGreen()/255f,wutcl.getBlue()/255f, (float)(1-wut.getProgress())));
	}
	
	private static void simpleRender(Entity wut, GraphicsEngine ge, Color c) {
		simpleFill(ge, (int) ((wut.getX() - offx()) * zoom),
				(int) ((wut.getY() - offy()) * zoom), c);
	}
	private static void simpleFill(GraphicsEngine ge, Coord pos, Color c) {
		simpleFill(ge, (int)(pos.getX()), (int)(pos.getY()), c, zoom, zoom);
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c) {
		simpleFill(ge, x, y, c, zoom, zoom);
	}
	private static void simpleFill(GraphicsEngine ge, int x, int y, Color c, int xs, int ys) {
		for (int mx = 0; mx < xs; mx++) {
			for (int my = 0; my < ys; my++) {
				ge.seta(mx + x, my + y, c);
			}
		}
	}
}
// <teamviewer>
